(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    458853,      12216]
NotebookOptionsPosition[    454315,      12064]
NotebookOutlinePosition[    454671,      12080]
CellTagsIndexPosition[    454628,      12077]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[TextData[{
 "Utilizing Vector Notation in ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 ": Example 3\[Dash]Motion from Relative Position"
}], "Section",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Input the definitions for the vector operations", "Subsection"],

Cell["\<\
Input the vector definition with the command that follows.  The path will \
depend on where  the definitions reside on the local system.\
\>", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
Get[StringJoin[NotebookDirectory[],\"vectors3.m\"]]\
\>", "Input",
 CellChangeTimes->{3.5184566946056004`*^9, 3.53626532414038*^9},
 AspectRatioFixed->True],

Cell[BoxData["\<\"These Engineering Vector algorithms are copyright Alan A. \
Barhorst\"\>"], "Print",
 CellChangeTimes->{3.5184566963528*^9, 3.5362653343197107`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Define the symbols used for Unit Vectors", "Subsection"],

Cell[TextData[{
 "Define Unit Vectors  for however many frames we need for the system. For \
this example we will use three frames of reference, with the frame ",
 StyleBox["N",
  FontWeight->"Bold"],
 " being the Newtonian frame denoted by the usual ",
 Cell[BoxData[
  FormBox[
   OverscriptBox["i", "^"], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   OverscriptBox["j", "^"], TraditionalForm]]],
 " vectors.  "
}], "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{"b", "[", "a_", "]"}], ":=", 
  RowBox[{"unitVector", "[", 
   RowBox[{"B", ",", "b", ",", "a"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"c", "[", "a_", "]"}], ":=", 
  RowBox[{"unitVector", "[", 
   RowBox[{"C", ",", "c", ",", "a"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"d", "[", "a_", "]"}], ":=", 
  RowBox[{"unitVector", "[", 
   RowBox[{"D", ",", "d", ",", "a"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.5184566989424*^9, 3.5184566989424*^9}},
 AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Example from Textbook", "Subsection"],

Cell[TextData[{
 "In this example we will use the tools calculate the velcity and \
acceleration of the slider ",
 StyleBox["C",
  FontSlant->"Italic"],
 " in the slider-crank shown below.  See lesson 8.3."
}], "Text"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 0.521739
200 dict begin
MathPictureStart
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0 1 0 1 [
[ 0 0 0 0 ]
[ 1196 624 0 0 ]
] MathScale
% Start of Graphics
%!PS-Adobe-2.1 EPSF-1.2

%%Creator: Logitech FotoTouch Color Version 1.1

%%Title: C:\\USERS\\BOOK\\ASLIDER.EPS

%%CreationDate: Mon Aug 29 17:23:40 1994

%%BoundingBox: 0 0 1196 624

%%EndComments

gsave

/picstr 150 string def

1196 624 scale

1196 624 1 [1196 0 0 -624 0 624] {currentfile picstr readhexstring pop}

image

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF83FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF83FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF81FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF81FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF807FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC07FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC07FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF81FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC07FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC07FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC07FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC07FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC07FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC07FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC07FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC07FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC07FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC07FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC07FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC07FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00F7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00000FFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE000007FFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE000001FFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0000007FFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0000003FFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE007F800FFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00FFE007FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFF803FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFFE01FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFF80FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF803FFFFC07FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF803FFFFE03FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF803FFFFF01FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF803FFFFF80FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFFF807FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFFFC07FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFFFFE03FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFFFFF03FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00FFFFFF01FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00FFFFFF01FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00FFFFFF01FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC007FFFFC01FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE003FFFF001FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE000FFF0001FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000000003FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC000000007FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00000001FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80000003FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000001FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0000FFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00007FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00001FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00000FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000003FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0000000FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00BC0007FFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF807FFF003FFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF81FFFF801FFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF03FFFFE00FFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF03FFFFF007FFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF07FFFFF807FFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF07FFFFFC03FFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF87FFFFFC01FFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF87FFFFFE01FFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFFF80FFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF807FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC07FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC07FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE03FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFFFFFFFFFFFFFFFFFFFFFFFFE01FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC3FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE03FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0003FFFFFFFFFFFFFFFFFFFFFFFFC01FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800FFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE03FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00000FFFFFFFFFFFFFFFFFFFFFFE0401FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0003FFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF03FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000003FFFFFFFFFFFFFFFFFFFFFC0001FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0001FFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF03FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0000003FFFFFFFFFFFFFFFFFFFFF80001FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000007FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF03FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80000001FFFFFFFFFFFFFFFFFFFFF00003FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE000003FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF01FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00000000FFFFFFFFFFFFFFFFFFFFF00003FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC000003FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00000000FFFFFFFFFFFFFFFFFFFFE00403FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80000007FFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0007C0007FFFFFFFFFFFFFFFFFFFC00C07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80000001FFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8001FE0007FFFFFFFFFFFFFFFFFFFC00C07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000000007FFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000FC03FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000FFFC007FFFFFFFFFFFFFFFFFFF801E07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000000001FFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80000403FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFE003FFFE003FFFFFFFFFFFFFFFFFFF003E07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00000000000FFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000000003FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00FFFFF003FFFFFFFFFFFFFFFFFFF007E07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE000000000003FFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC000000003FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFFFFC07FFFFFFFFFFFFFFFFFFE00FE07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0000000000003FFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0000000001FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFF803FFFFFE07FFFFFFFFFFFFFFFFFFC01FE07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00000000000007FFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80000000000FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFF807FFFFFF07FFFFFFFFFFFFFFFFFF801FE07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000000FC000000FFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE000003000007FFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFFFFFF8FFFFFFFFFFFFFFFFFFF003FC07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000000FF0000000FFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0001FFF00003FFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFFFFFFFFFFFFFFFFFFFFFFFFFE007FC07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0000001FFF0000001FFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0001FFFF80000FFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFF01FFFFFFFFFFFFFFFFFFFFFFFFFFE00FFC07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0000001FFFE0000001FFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0007FFFF000007FFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFFFFFFFFC00FFC07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00100003FFFFE0000003FF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE007FFFFE00F003FFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFFFFFFFF801FFC07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00380007FFFFFC0000003F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00FFFFFE01F803FFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFE03FFFFFFFFFFFFFFFFFFFFFFFFFF801FFC07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00FC000FFFFFFFC0000003

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFFF803FE01FFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFFFFFFFFFFFFFFFFFFFFFFFF003FFC07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800FF001FFFFFFFFE000000

7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFFF007FF00FFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFC07FFFFFFFFFFFFFFFFFFFFFFFFFE007FFC03FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF001FFF3FFFFFFFFFFC00000

0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFFC00FFF807FFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFC07FFFFFFFFFFFFFFFFFFFFFFFFFC00FFFC03FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFF00000

00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFF801FFF803FFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFC0FFFFFFFFFFFFFFFFFFFFFFFFFFC00FFFE03FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00FFFFFFFFFFFFFFFFF0000

001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFE007FFFC01FFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFC0FFFFFFFFFFFFFFFFFFFFFFFFFF801FFFE03FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF801FFFFFFFFFFFFFFFFFF000

0007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFF800FFFFE01FFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF80FFFFFFFFFFFFFFFFFFFFFFFFFF003FFFE03FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF003FFFFFFFFFFFFFFFFFFC00

00007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE01FFF001FFFFE00FFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF81FFFFFFFFFFFFFFFFFFFFFFFFFF003FFFE03FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE007FFFFFFFFFFFFFFFFFFFC0

00001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00FF8007FFFFF00FFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF81FFFFFFFFFFFFFFFFFFFFFFFFFE007FFFE03FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00FFFFFFFFFFFFFFFFFFFFF8

000003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF003C000FFFFFF007FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF81FFFFFFFFFFFFFFFFFFFFFFFFFE00FFFFE03FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFE

0000003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8000003FFFFFF807FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF81FFFFFFFFFFFFFFFFFFFFFFFFFC01FFFFE07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFF

E0000001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8000007FFFFFFC07FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF81FFFFFFFFFFFFFFFFFFFFFFFFFC01FFFFC07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFF

FE0000003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00001FFFFFFFC03FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF80FFFFFFFFFFFFFFFFFFFFFFFFF803FFFFC07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFF

FF80000003FFFFFFFFFFFFFFFFFFFFFFFFFFFFE00007FFFFFFFC03FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF80FFFFFFFFFFFFFFFFFFFFFFFFF003FFFFC07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFFF

FFF8000001FFFFFFFFFFFFFFFFFFFFFFFFFFFFF8001FFFFFFFFE01FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF80FFFFFFFFFFFFFFFFFFFFFFFFF007FFFFC07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFF

FFFE0000001FFFFFFFFFFFFFFFFFFFFFFFFFFFFE007FFFFFFFFE01FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFC0FFFFFFFFFFFFFFFFFFFFFFFFE007FFFFC07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFF

FFFFC0000003FFFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFF00FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFC0FFFFFFFFFFFFFFFFFFFFFFFFC00FFFFFC07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFF

FFFFF80000003FFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFF01FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFC07FFFFFFFFFFFFFFFFFFFFFFF801FFFFFC07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFF00000007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC1FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFFFFFFFFFFFFFFFFFFFFF801FFFFFC07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFE0000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFE03FFFFFFFFFFFFFFFFFFFFFFF003FFFFFC07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFC0000001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFFFFE003FFFFFC07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8007FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFC0000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFE00FFFFFFFFFFFFFFFFFFFFFFC007FFFFFC07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFF80000007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFFFFFFFFFFFFFFFFFFFC007FFFFFC07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFE0000000FFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFF803FFFFFFFFFFFFFFFFFFFFF800FFFFFFE07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFC0000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFF800FFFFFFE07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFC0000001FFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFC001FFFFF8FFFFFFFFFFFFFF0007FFFFFF0FFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFC0000003FFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0003FFFE01FFFFFFFFFFFFE0007FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE001FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFF00000007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80001FF8007FFFFFFFFFFFE0003FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE007FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFE0000000FFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0000000007FFFFFFFFFFFC0003FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00FFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFC0000001FFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0000000007FFFFFFFFFFF80003FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF801FFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFF80000003FFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000000007FFFFFFFFFFF80007FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF003FFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFF00000007FFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC000000007FFFFFFFFFFF00007FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE007FFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFC0000001FFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000000007FFFFFFFFFFF00007FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFF80000007FFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0000000FFFFFFFFFFFC00007FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFF80000007FF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC000007FFFFFFFFFFFC00603FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF00000007F7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0FFFFFFFFFFFFFFF800E03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFF0000000F7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF801E03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00FFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFC00000033FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF001E03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFF80000003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE003E03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFF0000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE007E03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFE0000001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00FE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFE0000007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800FE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFC000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF801FE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFC000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE003FE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFF00000007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE007FC03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFC0000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC007FC01FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFF80000007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00FFC01FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFE00000007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF801FFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF30000001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF001FFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7C0000003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF003FFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FC000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE003FFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FF8000001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC007FFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFE0000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00FFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFC0000001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800FFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFF80000007FFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF001FFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFE00000017FFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF003FFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFE0000001FFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE007FFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFC0000003FFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC007FFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFF0000000FFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00FFFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFF0000000FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF001FFFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFE0000001FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF001FFFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFF80000003FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE007FFFFE01FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFE00000007FFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC007FFFFE01FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFC0000000FFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800FFFFFE01FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFF00000000FFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFF07FFFFFFFFFFFFFFFFFFFFFF801FFFFFE01FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFF80000003FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFE03FFFFFFFFFFFFFFFFFFFFFF001FFFFFE01FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFE00000007FFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFE003FFFFFE01FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFF000000007FFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFF8003FFFFFFFFFFFFFFFFFFFFE007FFFFFE01FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFF000000000FFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFF0001FFFFFFFFFFFFFFFFFFFFC00FFFFFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF03FFFFFFFFFFFFF0000000001FFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFE00007FFFFFFFFFFFFFFFFFFF801FFFFFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF01FFFFFFFFFFFFF00200000001FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFC00003FFFFFFFFFFFFFFFFFFF801FFFFFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFC003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFFFFFFFFFFFF007C00000003FFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFC00000FFFFFFFFFFFFFFFFFFF003FFFFFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFF8007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFFFFFFFFFFFF007E00000000FFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFF8000007FFFFFFFFFFFFFFFFFF003FFFFFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFFFFFFFFFFFF007FF00000000FFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFF8000001FFFFFFFFFFFFFFFFFE007FFFFFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFE001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF01FFFFFFFFFFFFF007FFE00000003FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFF00000003FFFFFFFFFFFFFFFFC007FFFFFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFC003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFE01FFFFFFFFFFFFF00FFFFC00000007FFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFC000000007FFFFFFFFFFFFFFF800FFFFFFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFFFFFFFFFFE00FFFFFC00000003FFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFC001C00001FFFFFFFFFFFFFFF001FFFFFFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFF803FFFFFFFFFFFFE00FFFFFF800000007FFFFFFFFFF

FFFFFFFFFFFFFFFFFFF8003F000007FFFFFFFFFFFFFE003FFFFFFFF07FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFF807FFFFFFFFFFFFE00FFFFFFE00000001FFFFFFFFFF

FFFFFFFFFFFFFFFFFFF8007F800003FFFFFFFFFFFFFE003FFFFFFFF07FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFE007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFF807FFFFFFFFFFFFC01FFFFFFFE00000007FFFFFFFFF

FFFFFFFFFFFFFFFFFFF800FFC00000FFFFFFFFFFFFFC007FFFFFFFFDFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFC00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFF00FFFFFFFFFFFFFC01FFFFFFFFE00000003FFFFFFFF

FFFFFFFFFFFFFFFFFFF001FFF000001FFFFFFFFFFFFC00FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFE01FFFFFFFFFFFFFC03FFFFFFFFFE00000007FFFFFFF

FFFFFFFFFFFFFFFFFFE003FFFF800007FFFFFFFFFFF801FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFF003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFE01FFFFFFFFFFFFF803FFFFFFFFFF00000001FFFFFFF

FFFFFFFFFFFFFFFFFFE003FFFFE00007FFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFC000003FC03FFFFFFFFFFFFF807FFFFFFFFFFE00000001FFFFFF

FFFFFFFFFFFFFFFFFFC007FFFFFC0001FFFFFFFFFFF003FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFC00000007803FFFFFFFFFFFFF807FFFFFFFFFFFE00000001FFFFF

FFFFFFFFFFFFFFFFFF800FFFFFFF0000FFFFFFFFFFE007FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFC000000000003FFFFFFFFFFFFF807FFFFFFFFFFFFC00000003FFFF

FFFFFFFFFFFFFFFFFF800FFFFFFFC0007FFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFF8000000000003FFFFFFFFFFFFF807FFFFFFFFFFFFF00000000FFFF

FFFFFFFFFFFFFFFFFF000FFFFFFFE0003FFFFFFFFFC00FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFE0000000000017FFFFFFFFFFFFF00FFFFFFFFFFFFFFE00000001FFF

FFFFFFFFFFFFFFFFFF001FFFFFFFF8001FFFFFFFFF801FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFC0000000000037FFFFFFFFFFFFF00FFFFFFFFFFFFFFFF00000003FF

FFFFFFFFFFFFFFFFFE003FFFFFFFFC000FFFFFFFFF001CFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFF800003C3000037FFFFFFFFFFFFF00FFFFFFFFFFFFFFFFE00000007F

FFFFFFFFFFFFFFFFFE007FFFFFFFFF0003FFFFFFFF00383FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFF800FFFFFF00037FFFFFFFFFFFFF00FFFFFFFFFFFFFFFFFE00000007

FFFFFFFFFFFFFFFFFC007FFFFFFFFF8001FFFFFFFE00701FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFF003FFFFFF00017FFFFFFFFFFFFF00FFFFFFFFFFFFFFFFFF80000001

FFFFFFFFFFFFFFFFFC007FFFFFFFFFC001FFFFFFFC00701FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFF00FFFFFFE00003FFFFFFFFFFFFE00FFFFFFFFFFFFFFFFFFF0000000

3FFFFFFFFFFFFFFFF800FFFFFFFFFFF0007FFFFFFC00F01FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFF01FFFFFF800003FFFFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFE000000

07FFFFFFFFFFFFFFF800FFFFFFFFFFF8001FFFFFF800E01FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFE001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFE03FFFFFF000003FFFFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFF800000

01FFFFFFFFFFFFFFF800FFFFFFFFFFF8000FFFFFF000E01FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFFFF

FFFFFFFFFFFFFFFFFFFFFFFC003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFE03FFFFFC003001FFFFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFFF00000

001FFFFFFFFFFFFFF001FFFFFFFFFFFC0007FFFFE001E01FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00007FFFFF

FFFFFFFFFFFFFFFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFE01FFFFF000FC00FFFFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFFFF0000

0003FFFFFFFFFFFFE001FFFFFFFFFFFF0001FFFFC007E01FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000001FFFFF

FFFFFFFFFFFFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFE00FFFFC003FE003FFFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFFFFC000

00007FFFFFFFFFFFE001FFFFFFFFFFFF8000FFFFC00FC01FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8000000FFFFF

FFFFFFFFFFFFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFE00FFFF8007FF003FFFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFFFFF000

00001FFFFFFFFFFFC001FFFFFFFFFFFF80007FFF800FC03FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800000007FFFF

FFFFFFFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFE001FFC001FFF800FFFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFFFFFF00

000003FFFFFFFFFFC003FFFFFFFFFFFFE0003FFF801FC03FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC000000003FFFF

FFFFFFFFFFFFFFFFFFFFFFC00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFF000020003FFFC007FFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFFFFFFE0

0000003FFFFFFFFF8007FFFFFFFFFFFFF0001FFF001FC03FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00000FFE01FFFF

FFFFFFFFFFFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFF80000000FFFFE003FFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFFFFFFFF

00000007FFFFFFFF800FFFFFFFFFFFFFFC000FFE003FC03FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00003FFF00FFFF

FFFFFFFFFFFFFFFFFFFFFF003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFC0000001FFFFF001FFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFFFFFFFF

C0000001FFFFFFFF801FFFFFFFFFFFFFFE000FFE003FC03FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00001FFFF807FFF

FFFFFFFFFFFFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFE0000007FFFFF000FFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFFFFFFFF

F80000003FFFFFFF001FFFFFFFFFFFFFFF0003FC007FE03FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00007FFFF807FFF

FFFFFFFFFFFFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFF000000FFFFFF000FFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFFFFFFFF

FC0000000FFFFFFF001FFFFFFFFFFFFFFF8003F8007FE03FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80007FFFFFE03FFF

FFFFFFFFFFFFFFFFFFFFF000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFE00007FFFFFF6003FFFFFFFFFE01FFFFFFFFFFFFFFFFFFFFFFFFFF

FFC0000001FFFFFE003FFFFFFFFFFFFFFFC001F800FFE03FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0003FFFFFFE03FFF

FFFFFFFFFFFFFFFFFFFFE001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFE003FFFFFFF7803FFFFFFFFFF01FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFC0000003FFFFE007FFFFFFFFFFFFFFFF0007001FFE03FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF001FFFFFFFF01FFF

FFFFFFFFFFFFFFFFFFFFC003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7C03FFFFFFFFFF01FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFC0000001FFFC00FFFFFFFFFFFFFFFFF8000003FFE03FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF003FFFFFFFF81FFF

FFFFFFFFFFFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7C03FFFFFFFFFF01FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFE0000000FFFC00FFFFFFFFFFFFFFFFF8000003FFE03FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFFFFFFFF80FFF

FFFFFFFFFFFFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7F03FFFFFFFFFF00FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFC00000007F800FFFFFFFFFFFFFFFFF8000007FFE03FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF01FFFFFFFFF80FFF

FFFFFFFFFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7F87FFFFFFFFFF00FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFF00000003F801FFFFFFFFFFFFFFFFF800000FFFE03FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF03FFFFFFFFF80FFF

FFFFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFF00FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFE0000000F001FFFFFFFFFFFFFFFFF000000FFFE03FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF07FFFFFFFFF80FFF

FFFFFFFFFFFFFFFFFFF8007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFF80FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFC0000000003FFFFFFFFFFFFFFFFF000001FFFC03FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF87FFFFFFFFF80FFF

FFFFFFFFFFFFFFFFFFF8007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFF80FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFF0000000003FFFFFFFFFFFFFFFFE000001FFFC03FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFFFFFFFFFF80FFF

FFFFFFFFFFFFFFFFFFF000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFF807FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFF800000007FFFFFFFFFFFFFFFFC000007FFFC03FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80FFF

FFFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFF807FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFF00000007FFFFE00FFFFFFFFF8000007FFFC07FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80FFF

FFFFFFFFFFFFFFFFFFC003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFF807FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFF80000003FFFF8003FFFFFFFF801800FFFFC07FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFF

FFFFFFFFFFFFFFFFFF8007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFC07FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFF00000007FFC0000FFFFFFFF003001FFFFC07FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00FFF

FFFFFFFFFFFFFFFFFF000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFC03FFFFFFFFFFFFFFFFFFFFFFFFF

007FFFFFFFFE00000001E000007FFFFFFF003001FFFF807FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE01FFF

FFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFC03FFFFFFFFFFFFFFFFFFFFF0000

000000FFFFFFC00000000000003FFFFFFE004003FFFF807FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFF

FFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFF00000

00000007FFFFC00000000000001FFFFFFC004007FFFF807FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF803FFF

FFFFFFFFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFE3FFFFFFFFFFFFFE00FFFFFFFFFFFFFFFE700000000

00000003FFFFF00000000000001FFFFFFC008007FFFF80FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF803FFF

FFFFFFFFFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFC000000FFFFFFFFFC000803F00000000000000000000

00000003FFFFF00000000000000FFFFFF801800FFFFF80FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF003FFF

FFFFFFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFE00000000000FFFFFE00000000000000000000000000000

00000001FFFFF00000000000000FFFFFF803001FFFFF80FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC007FFF

FFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFC0000000000000030000000000000000000000000000000

00000001FFFFE000000000000007FFFFF002001FFFFF80FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFFFFFFFFFFFFFFFFFFFFFFFFFF800FFFF

FFFFFFFFFFFFFFFFC00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFF80000000000000000000000000000000000000000000000

00000003FFFFC001E00000000007FFFFE006003FFFFF00FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE001FFFF

FFFFFFFFFFFFFFFF801FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFF80000000000000000000000000000000000000000000000

00000003FFFFC003FC0000000007FFFFE00C007FFFFF00FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8003FFFF

FFFFFFFFFFFFFFFF003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFF800000000000000000000000000000000000000000007FF

FFFFF03FFFFF8003FF8000000007FFFFC008007FFFFF007FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0007FFFF

FFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFF800000000000000000000000000000000000000000FFFFF

FFFFFFFFFFFF0007FFF000000007FFFF800000FFFFFF007FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000FFFFF

FFFFFFFFFFFFFFF8007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFC01FF3FFCC0000000000000000009FFFF3FFFF7FFFFFFFF

FFFFFFFFFFFE000FFFF800000007FFFF800001FFFFFF00FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800001FFFFF

FFFFFFFFFFFFFFF000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFF80000000003FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFC001FFFFC0000000FFFFF000003FFFFFF00FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE000003FFFFF

FFFFFFFFFFFFFFE001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFF003FFFFFEFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFC001FFFFE0000000FFFFE000003FFFFFF00FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC000003FFFFF

FFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFF8003FFFFF0000000FFFFE000007FFFFFF00FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC000001FFFFF

FFFFFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFF0003FFFFF8000001FFFFC00000FFFFFFE00FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC000000FFFFF

FFFFFFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFF0007FFFFF8000001FFFF800000FFFFFFE00FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0000003FFFF

FFFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFE000FFFFFF8000003FFFF800001FFFFFFE00FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00000007FFF

FFFFFFFFFFFFFC003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFC001FFFFFFC000007FFFF000001FFFFFFE01FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80000003FFF

FFFFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFF8001FFFFFFC000007FFFE000003FFFFFFE01FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0F80000FFF

FFFFFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFF8003FFFFFFE00000FFFFE000007FFFFFFE01FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8007FF

FFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFF0007FFFFFFF80001FFFFC000007FFFFFFF01FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF801FF

FFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFE000FFFFFFFFC0003FFFF800000FFFFFFFF01FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00FF

FFFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFC001FFFFFFFFF000FFFFF800001FFFFFFFF81FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007F

FFFFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFF8001FFFFFFFFF801FFFFF000001FFFFFFFF81FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF803F

FFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFF8003FFFFFFFFFF1FFFFFE000003FFFFFFFFC3FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01F

FFFFFFFFFFFE001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFF0007FFFFFFFFFFFFFFFFC000007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF01F

FFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFE000FFFFFFFFFFFFFFFFF800000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80F

FFFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFC001FFFFFFFFFFFFFFFFF800001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80F

FFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFC003FFFFFFFFFFFFFFFFF000003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80F

FFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFF8007FFFFFFFFFFFFFFFFE000003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC07

FFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFF000FFFFFFFFFFFFFFFFFE000007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF807

FFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFC001FFFFFFFFFFFFFFFFFC000007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF807

FFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFC003FFFFFFFFFFFFFFFFFC00000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80F

FFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFF0007FFFFFFFFFFFFFFFFF8000007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00F

FFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFE000FFFFFFFFFFFFFFFFFF0020001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00F

FFFFFFFFF000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFC000FFFFFFFFFFFFFFFFFE0060001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800F

FFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFF8001FFFFFFFFFFFFFFFFFC00C0001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF001F

FFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFF8003FFFFFFFFFFFFFFFFF80180001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8003F

FFFFFFFF8007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFE0007FFFFFFFFFFFFFFFFF80180001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80007F

FFFFFFFF000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFC000FFFFFFFFFFFFFFFFFF00300001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE3FFE0000FF

FFFFFFFE001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFF0001FFFFFFFFFFFFFFFFFF00600001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800000001FF

FFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFE0003FFFFFFFFFFFFFFFFFC00400201FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000000003FF

FFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFE0007FFFFFFFFFFFFFFFFFC00400601FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00000000FFF

FFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFE000FFFFFFFFFFFFFFFFFF800800E01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8000000FFFF

FFFFFFF003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFE000FFFFFFFFFFFFFFFFFF801001E01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8000003FFFF

FFFFFFE007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFE000FFFFFFFFFFFFFFFFFF003003E03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00000FFFFF

FFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFF0003FFFFFFFFFFFFFFFFE006003E03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0000FFFFFF

FFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFF0001FFFFFFFFFFFFFFFFE00E007E03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFFFFF

FFFFFE001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFF80003FFFFFFFFFFFFFFFC01C00FE03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFC003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFC00007FFFFFFFFFFFFFFC01800FE03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFF00003FFFFFFFFFFFFFF803801FE03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFF00000FFFFFFFFFFFFFF803003FE03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFE001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFC00003FFFFFFFFFFFFF006007FE03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFE00000FFFFFFFFFFFFE004007FE03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFF000007FFFFFFFFFFFE00000FFE03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFF801FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFE00000FFFFFFFFFFFC00801FFC03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFF800007FFFFFFFFFF801001FFC03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFC003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFE00000FFFFFFFFFF803003FFE03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFF8007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFF000003FFFFFFFFF000007FFE03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFF000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFF80000FFFFFFFFF000007FFE03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFE001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFC00001FFFFFFFE00000FFFE03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFE001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFE000007FFFFFFE00000FFFE03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FF8007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFC00000FFFFFFC00001FFFC03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFF000003FFFFF800003FFFC03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFC00000FFFFF800003FFFC03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FE001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFF000003FFFF000007FFFC03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFF8000007FFF00000FFFFC01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

F800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFE000001FFE00000FFFFC01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

F000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFF800000FFE00001FFFFC01FFFFFFFFFFFFFFC7FFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

E003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFF800007FC00003FFFFC03FFFFFFFFFFFFFF81FFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

C007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFF00000FC00003FFFFC03FFFFFFFFFFFFFF803FFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFE00007800007FFFFC03FFFFFFFFFFFFFF801FFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFC000000000FFFFFC03FFFFFFFFFFFFFFC003FFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE

003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFF000000000FFFFFE03FFFFFFFFFFFFFFE001FFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC

007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFF800000001FFFFFE07FFFFFFFFFFFFFFF8007FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8

007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFE00000003FFFFFE07FFFFFFFFFFFFFFFE001FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0

00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF00000003FFFFFF07FFFFFFFFFFFFFFFF8007FFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0

01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF80000007FFFFFF0FFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0

03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFD000000FFFFFFFFFFFFFFFFFFFFFFFFFF800FFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80

07FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFF800001FFFFFFFFFFFFFFFFFFFFFFFFFFE001FFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00

0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFE00001FFFFFFFFFFFFFFFFFFFFFFFFFFF8003FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00

1FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFE00003FFFFFFFFFFFFFFFFFFFFFFFFFFFF000FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00

3FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFF00003FFFFFFFFFFFFFFFFFFFFFFFFFFFF8003FFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800

7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFF80007FFFFFFFFFFFFFFFFFFFFFFFFFFFFE001FFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFF8000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0007FFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE001

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFC001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8001FFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC003

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFE001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0007FFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC001FFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE001F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFE007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0003FFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC003F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC000FFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8007F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFF8003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0003FFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000FF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFF0003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC000FFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE001FF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFE0003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0001FFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC003FF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFE0003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80007FFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8007FF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFC0003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0001FFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000FFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFC0003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80007FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE001FFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFF80003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0003FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC003FFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFF00003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8000FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8007FFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFF00203FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0003FFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000FFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFC00603FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC000FFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE001FFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFC00607FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0001FFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8003FFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF800C07FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC000FFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8007FFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF801C07FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0003FF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE000FFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF003C07FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80007F

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC001FFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF007807FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0001F

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8003FFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFE007807FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC000F

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0007FFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFC00F80FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0001

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE001FFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFF800F80FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8000

7FFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC003FFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFF001F80FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE000

3FFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8007FFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFE003F80FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800

0FFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000FFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFC007F80FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00

03FFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE001FFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFC007F81FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0

00FFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC001FFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFF800FF81FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0

003FFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8003FFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFF000FF01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8

0007FFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0007FFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFF001FF01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE

0000FFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC001FFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFE001FF03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

C0007FFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC001FFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFE007FF03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

E0001FFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0003FFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFC00FFE03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

F80007FBFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0007FFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFF801FFE03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FE0001FBFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC000FFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFF001FFE03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FF80007BFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8003FFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFF003FFC07FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFC00039FFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0007FFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFE007FFC03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FF800001FFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000FFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFFFFFFFFFF

FFFFFFFFFFFFFFFC00FFFC03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FF000001FFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE001FFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF87FFFFFFFFF

FFFFFFFFFFFFFFF800FFFC03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FC0000003FFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8003FFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF83FFFFFFFFF

FFFFFFFFFFFFFFF801FFF807FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

F80000000FFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0007FFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF81FFFFFFFFF

FFFFFFFFFFFFFFF003FFF807FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

E000000007FFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE000FFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF81FFFFFFFFF

FFFFFFFFFFFFFFE007FFF807FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

8000040001FFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC001FFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF81FFFFFFFFF

FFFFFFFFFFFFFFC007FFF00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE

00000F00007FFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8003FFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80FFFFFFFFF

FFFFFFFFFFFFFF800FFFE00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC

00000FE0000FFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0007FFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80FFFFFFFFF

FFFFFFFFFFFFFF801FFFE00FFFFFFFFFFFFF80FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8

00000FE80001FFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE000FFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80FFFFFFFFF

FFFFFFFFFFFFFF003FFFE01FFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0

00000FF800007FFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC001FFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80FFFFFFFFF

FFFFFFFFFFFFFE007FFFE01FFFFFFFFFFFF8000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0

00001FF900001FFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC003FFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80FFFFFFFFF

FFFFFFFFFFFFFE007FFFE01FFFFFFFFFFFF00007FFFFFFFFFFFFFFFFFFFFFFFFFFFFC0

00001FF9E0000FFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8007FFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF807FFFFFFFF

FFFFFFFFFFFFFC00FFFFE03FFFFFFFFFFFE00003FFFFFFFFFFFFFFFFFFFFFFFFFFFE00

00001FFBF80007FFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE000FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF807FFFFFFFF

FFFFFFFFFFFFFC01FFFFE03FFFFFFFFFFFC00000FFFFFFFFFFFFFFFFFFFFFFFFFFF800

00001FFBFF0001FFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC001FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC07FFFFFFFF

FFFFFFFFFFFFF801FFFFE03FFFFFFFFFFF000000FFFFFFFFFFFFFFFFFFFFFFFFFFF000

00003FFFFFE000FFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8003FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC07FFFFFFFF

FFFFFFFFFFFFF003FFFFF07FFFFFFFFFFE0000007FFFFFFFFFFFFFFFFFFFFFFFFFC000

00003FFFFFF8007FFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0007FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFFFFFF

FFFFFFFFFFFFF007FFFFF87FFFFFFFFFFC001C003FFFFFFFFFFFFFFFFFFFFFFFFF0000

00003FFFFFFE007FFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE000FFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFFFFFF

FFFFFFFFFFFFE007FFFFFFFFFFFFFFFFF8007F001FFFFFFFFFFFFFFFFFFFFFFFFC0000

06007FFFFFFF807FFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC001FFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFFFFFF

FFFFFFFFFFFFC00FFFFFFFFFFFFFFFFFF000FFC01FFFFFFFFFFFFFFFFFFFFFFFF80000

06007FFFFFFFE0FFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8003FFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFFFFFF

FFFFFFFFFFFFC01FFFFFFFFFFFFFFFFFF001FFE00FFFFFFFFFFFFFFFFFFFFFFFF00000

0E00FFFFFFFFFDFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8003FFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFFFFFF

FFFFFFFFFFFF803FFFFFFFFFFFFFFFFFE003FFF00FFFFFFFFFFFFFFFFFFFFFFFC00000

1C00FFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0007FFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFFFFFF

FFFFFFFFFFFF007FFFFFFFFFFFFFFFFFC007FFF007FFFFFFFFFFFFFFFFFFFFFF000000

3C00FFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC000FFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFFFFFFF

FFFFFFFFFFFE00FFFFFFFFFFFFFFFFFF800FFFF807FFFFFFFFFFFFFFFFFFFFFE000000

3C00FFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8003FFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFFFFFFF

FFFFFFFFFFFE01FFFFFFFFFFFFFFFFFF801FFFF807FFFFFFFFFFFFFFFFFFFFFC000700

7801FFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0007FFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE01FFFFFFFF

FFFFFFFFFFFC01FFFFFFFFFFFFFFFFFF003FFFF803FFFFFFFFFFFFFFFFFFFFF8000F00

F803FFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE000FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE01FFFFFFFF

FFFFFFFFFFF803FFFFFFFFFFFFFFFFFE007FFFF803FFFFFFFFFFFFFFFFFFFFF0003E01

F803FFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC001FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE01FFFFFFFF

FFFFFFFFFFF803FFFFFFFFFFFFFFFFFE007FFFF803FFFFFFFFFFFFFFFFFFFFE0007E01

F007FFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8003FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0007FFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF01FFFFFFFF

FFFFFFFFFFF007FFFFFFFFFFFFFFFFFC00FFFFF803FFFFFFFFFFFFFFFFFFFFE001FC03

F007FFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0007FFFFFFFFFF83FFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC000007FFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF01FFFFFFFF

FFFFFFFFFFE007FFFFFFFFFFFFFFFFF801FFFFF803FFFFFFFFFFFFFFFFFFFFE003F807

F007FFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC001FFFFFFFFFFE000003

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC000000003FF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFFFFFFF

FFFFFFFFFFC01FFFFFFFFFFFFFFFFFF003FFFFF003FFFFFFFFFFFFFFFFFFFFE00FF00F

F007FFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8003FFFFFFFFFFC000000

7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00000000001FF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFFFFFFF

FFFFFFFFFF801FFFFFFFFFFFFFFFFFE007FFFFF003FFFFFFFFFFFFFFFFFFFFF03FF01F

E00FFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0007FFFFFFFFFF8000000

0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE000000000007F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFFFFFFF

FFFFFFFFFF003FFFFFFFFFFFFFFFFFC00FFFFFE007FFFFFFFFFFFFFFFFFFFFF07FE01F

E00FFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE000FFFFFFFFFFF0000000

07FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE000000000007F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFFFFFFF

FFFFFFFFFF007FFFFFFFFFFFFFFFFFC01FFFFFE007FFFFFFFFFFFFFFFFFFFFF87FE03F

E00FFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC001FFFFFFFFFFF0000000

00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00001BFFC003F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFFFFFFF

FFFFFFFFFE007FFFFFFFFFFFFFFFFF803FFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFC07F

C01FFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0001FFFFFFFFFFE0000000

003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0007FFFFF801F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFFFFFFF

FFFFFFFFFC00FFFFFFFFFFFFFFFFFF803FFFFF000FFFFFFFFFFFFFFFFFFFFFFFFFC07F

C01FFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0003FFFFFFFFFFC0003F00

000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00FFFFFFFF01F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFFFFFFF

FFFFFFFFF801FFFFFFFFFFFFFFFFFF007FFFFE000FFFFFFFFFFFFFFFFFFFFFFFFF80FF

C01FFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0007FFFFFFFFFF8001FFF8

0007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE07FFFFFFFFC0F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFFFFFFF

FFFFFFFFF801FFFFFFFFFFFFFFFFFE007FFFF8001FFFFFFFFFFFFFFFFFFFFFFFFF01FF

803FFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8000FFFFFFFFFFF0007FFFF

0003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0FFFFFFFFFC0F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFFFFF

FFFFFFFFF003FFFFFFFFFFFFFFFFFE007FFFE0003FFFFFFFFFFFFFFFFFFFFFFFFE01FF

803FFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0001FFFFFFFFFFF001FFFFF

C000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC7FFFFFFFFE07

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFFFFF

FFFFFFFFE007FFFFFFFFFFFFFFFFFC0000000000FFFFFFFFFFFFFFFFFFFFFFFFFE03FF

007FFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0003FFFFFFFFFFE001FFFFF

F000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFE07

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFFFFF

FFFFFFFFC007FFFFFFFFFFFFFFFFFC0000000001FFFFFFFFFFFFFFFFFFFFFFFFFC07FF

007FFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8000FFFFFFFFFFFE003FFFFF

FC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE07

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFFFFF

FFFFFFFF8007FFFFFFFFFFFFFFFFF80000000007FFFFFFFFFFFFFFFFFFFFFFFFF807FF

007FFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8000FFFFFFFFFFFC00FFFFFF

FF003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF07

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFFFFF

FFFFFFFF8007FFFFFFFFFFFFFFFFF8000000000FFFFFFFFFFFFFFFFFFFFFFFFFF00FFF

007FFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0001FFFFFFFFFFFC01FFFFFF

FF801FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF03

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFFFFF

FFFFFFFF0003FFFFFFFFFFFFFFFFF0000000003FFFFFFFFFFFFFFFFFFFFFFFFFE01FFF

00FFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0003FFFFFFFFFFF801FFFFFF

FFC00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF03

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFFFFF

FFFFFFFF0003FFFFFFFFFFFFFFFFF0000000007FFFFFFFFFFFFFFFFFFFFFFFFFE01FFF

00FFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80007FFFFFFFFFFF003FFFFFF

FFE0007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE07

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF83FFF007FFFFFFF

FFFFFFFE0001FFFFFFFFFFFFFFFFE0000000007FFFFFFFFFFFFFFFFFFFFFFFFFC03FFF

00FFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00007FFFFFFFFFFF003FFFFFF

FFF0003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE07

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00003F007FFFFFFF

FFFFFFFC0000FFFFFFFFFFFFFFFFC0000000007FFFFFFFFFFFFFFFFFFFFFFFFF807FFF

81FFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00007FFFFFFFFFFE007FFFFFF

FFE0001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC07

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8000007007FFFFFFF

FFFFFFF800007FFFFFFFFFFFFFFFC01C0000003FFFFFFFFFFFFFFFFFFFFFFFFF80FFFF

C3FFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800003FFFFFFFFFFE00FFFFFFF

FF00001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC000000000FFFFFFFF

FFFFFFF000003FFFFFFFFFFFFFFF801F800A001FFFFFFFFFFFFFFFFFFFFFFFFF00FFFF

EFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800001FFFFFFFFFFC01FFFFFFE

0000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC000000001FFFFFFFF

FFFFFFF001001FFFFFFFFFFFFFFF803FFFFFC01FFFFFFFFFFFFFFFFFFFFFFFFE01FFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000000FFFFFFFFFFC01FFFFF40

0000001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8000000001FFFFFFFF

FFFFFFE003000FFFFFFFFFFFFFFF003FFFFFC00FFFFFFFFFFFFFFFFFFFFFFFFE03FFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0000007FFFFFFFFFC01FFFE000

0000001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE001F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000000001FFFFFFFF

FFFFFFC0078007FFFFFFFFFFFFFF007FFFFFE007FFFFFFFFFFFFFFFFFFFFFFFC03FFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0003003FFFFFFFF8001F800000

0000001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8001F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000000003FFFFFFFF

FFFFFFC00F8003FFFFFFFFFFFFFE007FFFFFF007FFFFFFFFFFFFFFFFFFFFFFF807FFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8000FC00FFFFFFFF00000000000

0000003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80003F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0007200001FFFFFFFF

FFFFFF801FE000FFFFFFFFFFFFFE007FFFFFF007FFFFFFFFFFFFFFFFFFFFFFF00FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0001FC007FFFFFFE00000000000

0000403FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00007F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE007FFFC001FFFFFFFF

FFFFFF001FE0007FFFFFFFFFFFFE00FFFFFFF003FFFFFFFFFFFFFFFFFFFFFFF00FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0003FF003FFFFFFF00000000000

00FFE03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00000001FF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE01FFFFF001FFFFFFFF

FFFFFE003FFE003FFFFFFFFFFFFC00FFFFFFF003FFFFFFFFFFFFFFFFFFFFFFE01FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0007FF801FFFFFFF00000000000

3FFFE03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00000007FF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE03FFFFF801FFFFFFFF

FFFFFC007FFF801FFFFFFFFFFFF8007FFFFFC003FFFFFFFFFFFFFFFFFFFFFFC03FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000FFFC00FFFFFFF800000000FF

FFFFE03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0000000FFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE07FFFFFC01FFFFFFFF

FFFFFC00FFFFE00FFFFFFFFFFFF8001FFFFF0003FFFFFFFFFFFFFFFFFFFFFF807FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0001FFFE00FFFFFFFC0000003FFF

FFFFC03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80000000FFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE07FFFFFC00FFFFFFFF

FFFFF801FFFFF00FFFFFFFFFFFF0000FFFF80007FFFFFFFFFFFFFFFFFFFFFF807FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0003FFFF007FFFFFFE000003FFFF

FFFF807FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00000007FF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE03FFFFF800FFFFFFFF

FFFFF001FFFFF807FFFFFFFFFFF00003FFE00007FFFFFFFFFFFFFFFFFFFFFF00FFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8000FFFFF803FFFFFFF003FFFFFFF

FFFF007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00000003FF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFFFC0007FFFFFFF

FFFFE003FFFFFC03FFFFFFFFFFE000000000000FFFFFFFFFFFFFFFFFFFFFFE01FFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0001FFFFFC03FFFFFFF807FFFFFFF

FFFC00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF801F7001FF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF003FFC00007FFFFFFF

FFFFE007FFFFFC01FFFFFFFFFFC000000000001FFFFFFFFFFFFFFFFFFFFFFC01FFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0003FFFFFE01FFFFFFF80FFFFFFFF

FFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000000000FFFFFFFF

FFFFC007FFFFFE01FFFFFFFFFFC000000000007FFFFFFFFFFFFFFFFFFFFFF803FFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80007FFFFFF00FFFFFFF807FFFFFFF

FF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF807F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8000000000FFFFFFFF

FFFF800FFFFFFF00FFFFFFFFFFC00000000003FFFFFFFFFFFFFFFFFFFFFFF807FFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0000FFFFFFF80FFFFFFFC07FFFFFFF

FE001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC000000001FFFFFFFF

FFFF001FFFFFFF007FFFFFFFFF80180000001FFFFFFFFFFFFFFFFFFFFFFFF00FFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFC1FCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0001FFFFFFF807FFFFFFC07FFFFFFF

F0007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE03F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE000000003FFFFFFFF

FFFF003FFFFFFF807FFFFFFFFF803F000000FFFFFFFFFFFFFFFFFFFFFFFFF00FFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFF800003FFFFFFFFFFFFFFFFFFFFFFFFFFFF80007FFFFFFFE03FFFFFFE03FFFFFFF

8001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF03F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80000003FFFFFFFFF

FFFC007FFFFFFFC03FFFFFFFFF003FE0001FFFFFFFFFFFFFFFFFFFFFFFFFE01FFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFF0000007FFFFFFFFFFFFFFFFFFFFFFFFFFF80007FFFFFFFE01FFFFFFE03FFFFFFE

0003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF01F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC000000FFFFFFFFFF

FFFC00FFFFFFFFC03FFFFFFFFF007FF80DFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFF80000003FFFFFFFFFFFFFFFFFFFFFFFFFFF0001FFFFFFFFF00FFFFFFE01FFFFFE0

001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF01F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800007FFFFFFFFFF

FFF801FFFFFFFFC03FFFFFFFFE007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF807FFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFC00000001FFFFFFFFFFFFFFFFFFFFFFFFFFE0003FFFFFFFFF80FFFFFFF00FFFFF00

007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE01F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0007FFFFFFFFFFF

FFF001FFFFFFFFC01FFFFFFFFE00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFF800000000FFFFFFFFFFFFFFFFFFFFFFFFFF80007FFFFFFFFFC07FFFFFF803BFE000

03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE01F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFF003FFFFFFFFE00FFFFFFFFC00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00FFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFF000000000FFFFFFFFFFFFFFFFFFFFFFFFFF0000FFFFFFFFFFC07FFFFFF800000000

07FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFE007FFFFFFFFE00FFFFFFFFC01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00FFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFC000000000FFFFFFFFFFFFFFFFFFFFFFFFBE0003FFFFFFFFFFE03FFFFFFE00000000

3FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF803F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFC00FFFFFFFFFF007FFFFFFFC01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FF80000000007FFFFFFFFFFFFFFFFFFFFFFFB80007FFFFFFFFFFF01FFFFFFF00000001

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FFFFFFFFFFE007F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FF800FFFFFFFFFF007FFFFFFF803FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF803FFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FB80000008007FFFFFFFFFFFFFFFFFFFFFFFB0000FFFFFFFFFFFF00FFFFFFF8000000F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF83FFFFFFFFF000FF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FF801FFFFFFFFFF807FFFFFFF803FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF803FFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FB8000039C007FFFFFFFFFFFFFFFFFFFFFFFA0001FFFFFFFFFFFF80FFFFFFFE000007F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF807FFFFFFF0000FF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FF001FFFFFFFFFF803FFFFFFF007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FB00001F9C007FFFFFFFFFFFFFFFFFFFFFFF80003FFFFFFFFFFFFC07FFFFFFFC001FFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000FFFFFF80001FF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FF003FFFFFFFFFF803FFFFFFF007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FA0000FFFE007FFFFFFFFFFFFFFFFFFFFFFF80007FFFFFFFFFFFFE03FFFFFFFF8FFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0001FFFF800001FF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FE007FFFFFFFFFF803FFFFFFE007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00FFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

F80003FFFE003FFFFFFFFFFFFFFFFFFFFFFF0000FFFFFFFFFFFFFE01FFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80001FFC000003FF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FC007FFFFFFFFFFC03FFFFFFE00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

F0000FFFFE003FFFFFFFFFFFFFFFFFFFFFFE0000FFFFFFFFFFFFFF01FFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC000000000000FFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

F800FFFFFFFFFFFC01FFFFFFE00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF803FFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

F0001FFFFC003FFFFFFFFFFFFFFFFFFFFFFC0003FFFFFFFFFFFFFF00FFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE000000000007FFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

F001FFFFFFFFFFFC01FFFFFFE00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF003FFF1FFFFF

FFFFFFFFFFFFFFFFFFF0

F0003FFFFC001FFFFFFFFFFFFFFFFFFFFFF80007FFFFFFFFFFFFFF80FFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80000000003FFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

F003FFFFFFFFFFFC01FFFFFFC01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFF0FFFFF

FFFFFFFFFFFFFFFFFFF0

F0007FFFF8001FFFFFFFFFFFFFFFFFFFFFF0000FFFFFFFFFFFFFFF807FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800000001FFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

E003FFFFFFFFFFFC01FFFFFFC01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00FFFE07FFFF

FFFFFFFFFFFFFFFFFFF0

F000FFFFF8001FFFFFFFFFFFFFFFFFFFFFC0001FFFFFFFFFFFFFFFC07FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000003FFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

C007FFFFFFFFFFFC01FFFFFFC01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00FFFE03FFFF

FFFFFFFFFFFFFFFFFFF0

F001FFFFF8000FFFFFFFFFFFFFFFFFFFFF80007FFFFFFFFFFFFFFFC07FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00003FFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

C00FFFFFFFFFFFFC01FFFFFFC03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFFE03FFFF

FFFFFFFFFFFFFFFFFFF0

F003FFFFD0000FFFFFFFFFFFFFFFFFFFFF8000FFFFFFFFFFFFFFFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

800FFFFFFFFFFFFE01FFFFFF803FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF803FFFE01FFFF

FFFFFFFFFFFFFFFFFFF0

F007FFFF800007FFFFFFFFFFFFFFFFFFFE0001FFFFFFFFFFFFFFFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

001FFFFFFFFFFFFE01FFFFFF803FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF807FFFE00FFFF

FFFFFFFFFFFFFFFFFFF0

F007FFFF800007FFFFFFFFFFFFFFFFFFFC0003FFFFFFFFFFF0FFFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

003FFFFFFFFFFFFE01FFFFFF803FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFE00FFFF

FFFFFFFFFFFFFFFFFFF0

F007FFFF800003FFFFFFFFFFFFFFFFFFF80007FFFFFFFFFFC01FFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE

007FFFFFFFFFFFFE01FFFFFF807FFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00FFFFF00FFFF

FFFFFFFFFFFFFFFFFFF0

F007FFFF000003FFFFFFFFFFFFFFFFFFF0001FFFFFFFFFFE001FFFF01FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC

007FFFFFFFFFFFFE01FFFFFFC07FFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFFFF00FFFF

FFFFFFFFFFFFFFFFFFF0

F007FFFC000401FFFFFFFFFFFFFFFFFFE0003FFFFFFFFFF8000FFFF01FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8

00FFFFFFFFFFFFFE01FFFFFFE0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFFF00FFFF

FFFFFFFFFFFFFFFFFFF0

F807FFF0000E01FFFFFFFFFFFFFFFFFFC0003FFFFFFFFFE0000FFFF01FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FFFFFFFFFFFFF8

00FFFFFFFFFFFFFE01FFFFFFE0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF803FFFFF00FFFF

FFFFFFFFFFFFFFFFFFF0

F803FF80001E00FFFFFFFFFFFFF07FFF8000BFFFFFFFFF80000FFFF01FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF07FFFFFFFFFFFF0

03FFFFFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFFF00FFFF

FFFFFFFFFFFFFFFFFFF0

F8000000003F007FFFFFFFFFFF8007FF0001FFFFFFFFFE00000FFFF01FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE03FFFFFFFFFFFE0

03FFFFFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFFF00FFFF

FFFFFFFFFFFFFFFFFFF0

FA000000007F003FFFFFFFFFFE00007E0003FFFFFFFFF800001FFFF01FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC007FFFFFFFFFFE0

07FFFFFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00FFFFFF00FFFF

FFFFFFFFFFFFFFFFFFF0

FA00000000FF801FFFFFFFFFFC000008000FFFFFFFFFC00000FFFFF01FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFF8000FFFFFFFFFFC0

0FFFFFFFFFFFFFFE00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFFFFF00FFFF

FFFFFFFFFFFFFFFFFFF0

FF00000001FFC01FFFFFFFFFF8000000000FFFFFFFFF800001FFFFF01FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFF80007FFFFFFFFF80

0FFFFFFFFFFFFFFE00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFFFFF00FFFF

FFFFFFFFFFFFFFFFFFF0

FF80000003FFE007FFFFFFFFE0000000001FFFFFFFF800000FFFFFE01FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800007FFFFFFFF80

1FFFFFFFFFFFFFFF00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF803FFFFFF807FFF

FFFFFFFFFFFFFFFFFFF0

FF80000007FFE003FFFFFFFF80000000003FFFFFFFF000001FFFFFE01FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800003FFFFFFFF00

3FFFFFFFFFFFFFFF00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF003FFFFFF807FFF

FFFFFFFFFFFFFFFFFFF0

FFC000001FFFF003FFFFFFFF00000000007FFFFFFFC00000FFFFFFE01FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8000007FFFFFFE00

3FFFFFFFFFFFFFFF00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFFFF807FFF

FFFFFFFFFFFFFFFFFFF0

FFF00003BFFFF801FFFFFFFE0000000000FFFFFFFF000003FFFFFFC01FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFF80000007FFFFF800

7FFFFFFFFFFFFFFF00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00FFFFFFF807FFF

FFFFFFFFFFFFFFFFFFF0

FFFC0007FFFFF801FFFFFFF80003800001FFFFFFFE000007FFFFFFC01FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFC0000003FFFFE000

7FFFFFFFFFFFFFFF00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00FFFFFFF807FFF

FFFFFFFFFFFFFFFFFFF0

FFFF00FFFFFFFC00FFFFFFF0000FE00001FFFFFFFC00001FFFFFFFC03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC3FFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00000003FFF8000

7FFFFFFFFFFFFFFF00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFFFFFF807FFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFE00FFFFFFE0003FF80000FFFFFFF800003FFFFFFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF83FFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0000000FFE0000

7FFFFFFFFFFFFFFF00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF803FFFFFFF807FFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFF00FFFFFFC0007FF00000FFFFFFF800007FFFFFFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF03FFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00000003FC0000

3FFFFFFFFFFFFFFF00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF803FFFFFFF807FFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFF80FFFFFF8000FFF000007FFFFFF00001FFFFFFFFE07FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00830780EEC1EFFFFFFFFFF

FFFFE0000000000007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00000000780000

1FFFFFFFFFFFFFFE00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFFFFF807FFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFC0FFFFFE0001FFE000001FFFFFF00003FFFFFFFFF07FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE000000000000005FFFFFFFF

FFFFC00000000000003FFFFFFFFFFFFFF8FFFFFFFFFFFFFFFFFFFFFFE0000000000000

0FFFFFFFFFFFFFFE00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE007FFFFFFF807FFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFF1FFFFFC0007FFC000001FFFFFF00003FFFFFFFFF8FFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFC3FFFFFFBE00003FFFFFFFFFFC000000000000000FFFFFFFF

FFFFC000000000000007FFFFFFFFFFFFE000043FFFFFFFFFFFFFFFFFFC000000000000

0FFFFFFFFFFFFFFE00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00FFFFFFFF807FFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFF8001FFF8000000FFFFFF0000000FFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFF8000800000000000FFFFFFFFFE000000000000001FFFFFFFF

FFFFC000000000000003FFFFFFFFFFFFE000000006FFFFFFFFFFFFFFFFC00000000000

07FFFFFFFFFFFFFE00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00FFFFFFFF803FFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFF0003FFF00000007FFFFF00000000000007FFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFF00000000000000007FFFFFFFFE000000000000003FFFFFFFF

FFFFC00000000000000FFFFFFFFFFFFFE00000000000007FFFFFFFFFFFF80000000000

07FFFFFFFFFFFFFE00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF801FFFFFFFF803FFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFE000FEFC00038003FFFFF00000000000000003FFFCFFFFFE00

00C080E3BFFFFFFFFFFFF0000000000000000FFFFFFFFFF00000000000001FFFFFFFFF

FFFFE00000000000007FFFFFFFFF7FFFE000000000000000007FFFFFFFF80000000000

07FFFFFFFFFFFFFE00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF803FFFFFFFF803FFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFC001F8000007E001FFFFF8000000000000000000007FFFF800

00000000003FFFFFFFFFF000000000000007FFFFFFFFFFFFFFFFF20006E07FFFFFFFFF

FFFFF807F800000007FFFFFFFFFF7FFFE0000000000000000003FFFFFFF80000000000

07FFFFFFFFFFFFFE00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFFFFFF803FFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFF80010000000FF001FFFFF8000000000000000000007FFFF800

00000000000FFFFFFFFFF00000000000001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFF00000000000000000001FFFFFF80000000000

03FFFFFFFFFFFFFC00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE007FFFFFFFF803FFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFF80000000001FF000FFFFFE000000000000000000007FFFF800

00000000000FFFFFFFFFF8000000000003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800000000000000000003FFFFF80000000000

007FFFFFFFFFFFFC00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00FFFFFFFFF803FFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFF00000000003FF800FFFFFF800000000000000000007FFFFC00

0000000000FFFFFFFFFFFE03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00000000000000003FFFFF80000000000

0001FFFFFFFE000000F8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFFFFFFFF803C01

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFE00100000003FFC00BFFFFFF80000000000000000007FFFFE00

000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFE000000000000007FFFFF80000000000

00000FFFFFFC00000000007FFFFFFFFFFFFFFFFFFFFFFFFFFFFF801FFFFFFFFFC00000

7FFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFC00300000007FFC003FFFFFFE000007FFFF80000000FFFFFF00

0FEE062A3FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBC00000001FFFFFFF80000000000

000001FFFFF800000000000000001FFFFFFFFFFFFFFFFFFFFFFF803FFFFFBFFFC00000

1FFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFC00700000007FFE003FFFFFFF80001FFFFFFFF80001FFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFE78007FFFFFFF80000000000

000001FFFFF80000000000000000007FFFFFFFFFFFFFFFFFFFFF007FFFFFFFFFC00000

0FFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFC00600000007FFE003FFFFFFFE00007FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00000000000

000003FFFFF80000000000000000001FFFFFFFFFFFFFFFFFFFFE007FFFFFFFFFC00000

01FFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFF800E00000003FFF003FFFFFFFF80003FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFF800000000000

00001FFFFFFC0000000000000000000FFFFFFFFFFFFFFFFFFFFC00FFFFFFFFFFC00000

00FFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFF800C00000003FFF003FFFFFFFFC0001FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFE000000000000

0007FFFFFFFC0000000000000000001FFFFFFFFFFFFFFFFFFFFC01FFFFFFFFFFC00000

007FFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFF801C00000003FFF801FFFFFFFFF80007FFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFF0000000000000

003FFFFFFFFE00000000000000000FFFFFFFFFFFFFFFFFFFFFF801FFFFFFFFFF800000

003FFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFF003C00000003FFF801FFFFFFFFFE0001FFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFF80000000000000

1FFFFFFFFFFFDFC0000000000005FFFFFFFFFFFFFFFFFFFFFFF803FFFFFFFFFF800000

000FFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFF003E00000003FFF800FFFFFFFFFF80007FFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFE00000000000000

7FFFFFFFFFFFFFFC0FF8CFFE001FFFFFFFFFFFFFFFFFFFFFFFF007FFFFFFFFFF8000FE

0007FFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFE007E00000003FFFC00FFFFFFFFFFE0003FFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFF0000000F8000000

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00FFFFFFFFFFF8003FF

8007FFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFE007E00000003FFFC00FFFFFFFFFFFC000FFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0000003F8000001

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFFFFFFFFFF000FFF

E003FFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFC00FF00000003FFFC007FFFFFFFFFFF0003FFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFF00000007F0000003

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFFFFFFFFFF001FFF

F800FFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFC00FF00000003FFFE007FFFFFFFFFFFC001FFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00000017E0000007

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF803FFFFFFFFFFF003FFF

FC00FFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFF800FF80000007FFFE007FFFFFFFFFFFF001FFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFF8000000FFC000003F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFFFFFFFFF003FFF

FE007FFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFF800FF8000000FFFFE007FFFFFFFFFFFF800FFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFF8000003FFC007007F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFFFFFFFFF007FFF

FE007FFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFF801FFC000001FFFFF003FFFFFFFFFFFFE00FFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFF8000007FF800FC1FF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00FFFFFFFFFFFF007FFF

FF007FFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFF801FFE00000FFFFFF003FFFFFFFFFFFFFC0FFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFF000001FFF800FFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00FFFFFFFFFFFF007FFF

FF003FFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFF001FFF0000FFFFFFF003FFFFFFFFFFFFFE1FFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000007FFF001FFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFFFFFFFFFFF007FFF

FF803FFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFF001FFF800FFFFFFFF003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFF80001FFFF003FFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF801FFFFFFFFFFFF007FFF

FF803FFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFF001FFFC03FFFFFFFF801FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8001FFFFE007FFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF003FFFFFFFFFFFF007FFF

FFC03FFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFF003FFFFCFFFFFFFFF801FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC007FFFFC007FFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFFFFFFFFFF007FFF

FFC01FFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFF003FFFFFFFFFFFFFF801FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FFFFFF800FFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00FFFFFFFFFFFFF007FFF

FFE01FFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFF003FFFFFFFFFFFFFF801FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF001FFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00FFFFFFFFFFFFF007FFF

FFE00FFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFF003FFFFFFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF001FFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFFFFFFFFFFFF807FFF

FFE00FFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFC00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE003FFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF803FFFFFFFFFFFFF807FFF

FFF007FFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFE007FFFFFFFFFFFFFFC00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE003FFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF003FFFFFFFFFFFFF807FFF

FFF007FFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFE007FFFFFFFFFFFFFFC00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00FFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE007FFFFFFFFFFFFF803FFF

FFF007FFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFE007FFFFFFFFFFFFFFC00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00FFFFFFFFFFFFFF803FFF

FFF007FFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFE007FFFFFFFFFFFFFFE007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF801FFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00FFFFFFFFFFFFFF803FFF

FFF003FFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFE007FFFFFFFFFFFFFFE007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF803FFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFFFFFFFFFFFFF803FFF

FFF003FFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFE007FFFFFFFFFFFFFFE007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF803FFFFFFFFFFFFFF803FFF

FFF003FFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFE007FFFFFFFFFFFFFFE007FF807FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF01FFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF003FFFFFFFFFFFFFF803FFF

FFF003FFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFE007FFFFFFFFFFFFFFE007FC003FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE03FFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFFFFFFFFFFFF803FFF

FFF003FFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFE007FFFFFFFFFFFFFFE003C0003FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE07FFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00FFFFFFFFFFFFFFFC03FFF

FFF003FFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFF003FFFFFFFFFFFFFFE00000001FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE07FFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE01FFFFFFFFFFFFFFFC03FFF

FFF003FFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFF003FFFFFFFFFFFFF9800000001FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC1FFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFFFFFFFFFFFFFFC03FFF

FFF003FFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFF003FFFFFFFF800000000000003FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF83FFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF803FFFFFFFFFFFFFFFC03FFF

FFF003FFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFF801FFA08000000000000000003FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF83FFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF807FFFFFFFFFFFFFFFE03FFF

FFF003FFFFFFFFFFFFF0

FFFFFFFFFFFF07FFFF8000000000000000000000001FFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF07FFFFFFFFF

FFFFFFFFFFFFF1FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFFFFFFFFFFFFFF07FFF

FFF003FFFFFFFFFFFFF0

FFFFFFFFFFE000F8000000000000000000000000003FFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0FFFFFFFFFF

FFFFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00FFFFFFFFFFFFFFFFFFFFFF

FFF003FFFFFFFFFFFFF0

FFFFFFFFFFC000000000000000000000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0FFFFFFFFFF

FFFFFFFFFFFFE007FFFFFFFFFFFFFFFFFFFFFFFFFC3FFE00FFFFFFFFFFFFFFFFFFFFFF

FFF003FFFFFFFFFFFFF0

FFFFFFFFFFC000000000000000000000000000007FFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80FFFFFFFFFF

FFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFF81FFC01FFFFFFFFFFFFFFFFFFFFFF

FFF003FFFFFFFFFFFFF0

FFFFFFFFFFC00000000000000000000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF807FFFFFFFFF

FFFFFFFFFFFFE0007FFFFFFFFFFFFFFFFFFFFFFFF807FC03FFFFFFFFFFFFFFFFFFFFFF

FFF007FFFFFFFFFFFFF0

FFFFFFFFFFC000000000000000000000008E0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF807FFFFFFFFF

FFFFFFFFFFFFF0001FFFFFFFFFFFFFFFFFFFFFFFF007F803FFFFFFFFFFFFFFFFFFFFFF

FFF007FFFFFFFFFFFFF0

FFFFFFFFFFC000000000000000000007FFFF8000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF807FFFFFFFFF

FFFFFFFFFFFFFC000FFFFFFFFFFFFFFFFFFFFFFFF007F007FFFFFFFFFFFFFFFFFFFFFF

FFF00FFFFFFFFFFFFFF0

FFFFFFFFFFE00000000000000000000FFFFF8000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3FFFFFFFFFF

FFFFFFFFFFFFFE0007FFFFFFFFFFFFFFFFFFFFFFE007E007FFFFFFFFFFFFFFFFFFFFFF

FFF80FFFFFFFFFFFFFF0

FFFFFFFFFFF00000000007FFFFF0000FFFFFA000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFF8001FFFFFFFFFFFFFFFFFFFFFFE007C00FFFFFFFFFFFFFFFFFFFFFFF

FFFC1FFFFFFFFFFFFFF0

FFFFFFFFFFF80000001FFFFFFFE0001FFFFFA000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFE000FFFFFFFFFFFFFFFFFFFFFFC007801FFFFFFFFFFFFFFFFFFFFFFF

FFFEFFFFFFFFFFFFFFF0

FFFFFFFFFFFE0000007FFFFFFFC0003FFFFF8001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFF0001FFFFFFFFFFFFFFFFFFFFFC00F001FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFBE0007FFFFFFF80007FFFFF0003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFE0003FFFFFFFFFFFFFFFFFFFFC00E003FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFE0007FFFFFFE0000FFFFFF0007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFF8001FFFFFFFFFFFFFFFFFFFFC01C007FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFE0007FFFFFFC0001FFFFFF0007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFC000FFFFFFFFFFFFFFFFFFFFC01C007FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFC000FFFFFFF80007FFFFFE000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFF0007FFFFFFFFFFFFFFFFFFF801C00FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFF8000FFFFFFF00007FFFFFE001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFF8001FFFFFFFFFFFFFFFFFFF801800FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFE0001FFFFFFE0001FFFFFFC003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFE000FFFFFFFFFFFFFFFFFFF003001FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFC0003FFFFFFC0003FFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFF8003FFFFFFFFFFFFFFFFFF003003FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFF80007FFFFFF8000FFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFE001FFFFFFFFFFFFFFFFFF002003FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFF0000FFFFFFF0001FFFFFFF000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0007FFFFFFFFFFFFFFFFF000007FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFE0001FFFFFFE0003FFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF8001FFFFFFFFFFFFFFFFF000007FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFC0003FFFFFFC0003FFFFFFC001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFC0007FFFFFFFFFFFFFFFF00000FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFF00007FFFFFFC0007FFFFFFC003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFF8001FFFFFFFFFFFFFFFE00001FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFE0000FFFFFFF80007FFFFFF8007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFE000FFFFFFFFFFFFFFFE00003FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFC0001FFFFFFF00003FFFFFF8007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFF8003FFFFFFFFFFFFFFE00003FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFF80001FFFFFFE00003FFFFFF000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFE001FFFFFFFFFFFFFFE00007FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFF00003FFFFFFE00003FFFFFE001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFF0007FFFFFFFFFFFFFE00007FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFC00003FFFFFFE00007FFFFFC001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFC001FFFFFFFFFFFFFC0000FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFF800003FFFFFFE0000FFFFFFC003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFF000FFFFFFFFFFFFFC0000FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFF800003FFFFFFF0003FFFFFF8003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3FFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFC003FFFFFFFFFFFFC0000FF07FFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFF000003FFFFFFF0003FFFFFF0003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE3FFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFE001FFFFFFFFFFFFC0001FE03FFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFF000003FFFFFFF0007FFFFFF0003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFF0007FFFFFFFFFFFC0007F8007FFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFF00001FFFFFFFF801FFFFFFF000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFF8001FFFFFFFFFFF80006C0007FFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFF00003FFFFFFFFC07FFFFFFE001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFC000FFFFFFFFFFF8000C00007FFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFF00007FFFFFFFFE0FFFFFFFE001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE1FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFE0007FFFFFFFFFF8000C00007FFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFF8003FFFFFFFFFFFFFFFFFFF003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC1FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFF8000FFFFFFFFFF8000000007FFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFF800FFFFFFFFFFFFFFFFFFFF007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC1FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFE0007FFFFFFFFF800000000FFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFC00FFFFFFFFFFFFFFFFFFFF007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF81FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFF0003FFFFFFFFF800000001FFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFE03FFFFFFFFFFFFFFFFFFFF80FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE03FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFC000FFFFFFFFF000000007FFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF1FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC07FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFE0003FFFFFFFF00000001FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF807FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFF0001FFFFFFFF00000003FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF81FFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFE000FFFFFFFF0000001FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF01FFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF8000FFFFFFE0000007FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF03FFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFE0007FFFFFE000001FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF07FFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFF0001FFFFFC000007FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE07FFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0007FFFFC00000FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC1FFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0001FFFF800007FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC3FFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8000FFFF80001FFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC7FFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0007FFF80007FFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8000FFF8001FFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0007FF8007FFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0001FFC00FFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0003FF03FFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF1FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE3FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC7FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF07FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0FFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0007FFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0FFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0001FFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC1FFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8000FFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC3FFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0003FFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC7FFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0003FFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0003FFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC001FFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF803FFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF07FFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

grestore

showpage

%%EOF


%End of Graphics
MathPictureEnd
end
\
\>"], "Graphics",
 ImageSize->{351, 183.0625},
 ImageMargins->{{16, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]],

Cell[TextData[{
 "First we will write the position of ",
 StyleBox["C",
  FontSlant->"Italic"],
 " with respect to ",
 StyleBox["a",
  FontSlant->"Italic"],
 "."
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"arc", "=", 
  RowBox[{
   RowBox[{"3", " ", 
    RowBox[{"Cos", "[", 
     RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], "i"}], " ", "+", " ", 
   RowBox[{"3", " ", 
    RowBox[{"Sin", "[", 
     RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], "j"}], " ", "-", " ", 
   RowBox[{"2", " ", 
    RowBox[{"Cos", "[", 
     RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}], " ", "i"}], " ", "-", " ", 
   RowBox[{"2", " ", 
    RowBox[{"Sin", "[", 
     RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}], " ", "j"}]}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "2"}], " ", 
   RowBox[{"Cos", "[", 
    RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}], " ", 
   OverscriptBox["\<\"i\"\>", "^"]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"Cos", "[", 
    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
   OverscriptBox["\<\"i\"\>", "^"]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"Sin", "[", 
    RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}], " ", 
   OverscriptBox["\<\"j\"\>", "^"]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"Sin", "[", 
    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
   OverscriptBox["\<\"j\"\>", "^"]}]}]], "Output",
 CellChangeTimes->{3.5184567018596*^9, 3.536265334454302*^9}]
}, Open  ]],

Cell[TextData[{
 "Next we differentiate in the Newtonian frame.  In a later example we will \
show a more general approach, for now we can take the Newtonian fram as \
denoted by the usual ",
 Cell[BoxData[
  FormBox[
   OverscriptBox["i", "^"], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   OverscriptBox["j", "^"], TraditionalForm]]],
 " vectors"
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"avc", "=", 
  RowBox[{
   RowBox[{"DvDt", "[", 
    RowBox[{"N", ",", "arc"}], "]"}], "//", "gatherVectors"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   OverscriptBox["\<\"j\"\>", "^"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}], " ", 
      RowBox[{
       SuperscriptBox["\[Alpha]", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}], "+", 
     RowBox[{"3", " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
      RowBox[{
       SuperscriptBox["\[Theta]", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "+", 
  RowBox[{
   OverscriptBox["\<\"i\"\>", "^"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}], " ", 
      RowBox[{
       SuperscriptBox["\[Alpha]", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}], "-", 
     RowBox[{"3", " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
      RowBox[{
       SuperscriptBox["\[Theta]", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.5184567030452003`*^9, 3.536265334481209*^9}]
}, Open  ]],

Cell["We can next find the acceleration.", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"axc", "=", 
  RowBox[{"DvDt", "[", 
   RowBox[{"N", ",", "avc"}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   OverscriptBox["\<\"j\"\>", "^"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Sin", "[", 
           RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}]}], " ", 
         SuperscriptBox[
          RowBox[{
           SuperscriptBox["\[Alpha]", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
        RowBox[{
         RowBox[{"Cos", "[", 
          RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}], " ", 
         RowBox[{
          SuperscriptBox["\[Alpha]", "\[Prime]\[Prime]",
           MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "+", 
     RowBox[{"3", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Sin", "[", 
           RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}], " ", 
         SuperscriptBox[
          RowBox[{
           SuperscriptBox["\[Theta]", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
        RowBox[{
         RowBox[{"Cos", "[", 
          RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
         RowBox[{
          SuperscriptBox["\[Theta]", "\[Prime]\[Prime]",
           MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}]}], ")"}]}], 
  "+", 
  RowBox[{
   OverscriptBox["\<\"i\"\>", "^"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"Cos", "[", 
          RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}], " ", 
         SuperscriptBox[
          RowBox[{
           SuperscriptBox["\[Alpha]", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
        RowBox[{
         RowBox[{"Sin", "[", 
          RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}], " ", 
         RowBox[{
          SuperscriptBox["\[Alpha]", "\[Prime]\[Prime]",
           MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "-", 
     RowBox[{"3", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"Cos", "[", 
          RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
         SuperscriptBox[
          RowBox[{
           SuperscriptBox["\[Theta]", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
        RowBox[{
         RowBox[{"Sin", "[", 
          RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
         RowBox[{
          SuperscriptBox["\[Theta]", "\[Prime]\[Prime]",
           MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{3.5184567044024*^9, 3.536265334516843*^9}]
}, Open  ]],

Cell["\<\
Now we no from the vector loop example that the angel \[Alpha] is dependent \
on the angle  \[Theta], so we can use the loop to relate the derivatives\
\>", "Text"],

Cell[TextData[{
 "First we write the vector loop for the complete mechanism.  ",
 "In each planar vector loop we can introduce only two unknowns. In this case \
we have \[Alpha] and ",
 StyleBox["h",
  FontSlant->"Italic"],
 " as unknowns. "
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"vLoop", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"3", " ", 
     RowBox[{"Cos", "[", 
      RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", "i"}], " ", "+", " ", 
    RowBox[{"3", " ", 
     RowBox[{"Sin", "[", 
      RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", "j"}], " ", "-", " ", 
    RowBox[{"2", " ", 
     RowBox[{"Cos", "[", 
      RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}], " ", "i"}], " ", "-", " ", 
    RowBox[{"2", " ", 
     RowBox[{"Sin", "[", 
      RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}], " ", "j"}], " ", "-", " ", 
    RowBox[{
     RowBox[{"h", "[", "t", "]"}], " ", 
     RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", "i"}], " ", "-", " ", 
    RowBox[{
     RowBox[{"h", "[", "t", "]"}], " ", 
     RowBox[{"Sin", "[", "\[Beta]", "]"}], " ", "j"}], " ", "-", " ", 
    RowBox[{"3", " ", "i"}]}], "//", "gatherVectors"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "3"}], "-", 
     RowBox[{"2", " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}]}], "+", 
     RowBox[{"3", " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}], "-", 
     RowBox[{
      RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
      RowBox[{"h", "[", "t", "]"}]}]}], ")"}], " ", 
   OverscriptBox["\<\"i\"\>", "^"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       RowBox[{"h", "[", "t", "]"}]}], " ", 
      RowBox[{"Sin", "[", "\[Beta]", "]"}]}], "-", 
     RowBox[{"2", " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}]}], "+", 
     RowBox[{"3", " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}]}], ")"}], " ", 
   OverscriptBox["\<\"j\"\>", "^"]}]}]], "Output",
 CellChangeTimes->{3.5184567054944*^9, 3.536265334549314*^9}]
}, Open  ]],

Cell["\<\
Remember the vector loop actually is equal to zero.  We will just carry that \
fact in our heads for now.\
\>", "Text"],

Cell["\<\
The first derivatives of the variables must be related through the same loop, \
so we have the following, after making \[Beta] constant.\
\>", "Text"],

Cell[BoxData[
 RowBox[{"SetAttributes", "[", 
  RowBox[{"\[Beta]", ",", "Constant"}], "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"velvLoop", "=", 
  RowBox[{"DvDt", "[", 
   RowBox[{"N", ",", "vLoop"}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   OverscriptBox["\<\"j\"\>", "^"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       RowBox[{"Sin", "[", "\[Beta]", "]"}]}], " ", 
      RowBox[{
       SuperscriptBox["h", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}], "-", 
     RowBox[{"2", " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}], " ", 
      RowBox[{
       SuperscriptBox["\[Alpha]", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}], "+", 
     RowBox[{"3", " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
      RowBox[{
       SuperscriptBox["\[Theta]", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "+", 
  RowBox[{
   OverscriptBox["\<\"i\"\>", "^"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       RowBox[{"Cos", "[", "\[Beta]", "]"}]}], " ", 
      RowBox[{
       SuperscriptBox["h", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}], "+", 
     RowBox[{"2", " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}], " ", 
      RowBox[{
       SuperscriptBox["\[Alpha]", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}], "-", 
     RowBox[{"3", " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
      RowBox[{
       SuperscriptBox["\[Theta]", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.5184567073196*^9, 3.5362653346200743`*^9}]
}, Open  ]],

Cell["\<\
Which is equal to zero, but we hold that for now. We now need to set up \
equations to relate first derivatives.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Vxcomp", "=", 
  RowBox[{"velvLoop", " ", ".", "i"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    RowBox[{"Cos", "[", "\[Beta]", "]"}]}], " ", 
   RowBox[{
    SuperscriptBox["h", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "+", 
  RowBox[{"2", " ", 
   RowBox[{"Sin", "[", 
    RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}], " ", 
   RowBox[{
    SuperscriptBox["\[Alpha]", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"Sin", "[", 
    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
   RowBox[{
    SuperscriptBox["\[Theta]", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}]}]], "Output",
 CellChangeTimes->{3.5184567081152*^9, 3.536265334648767*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Vycomp", "=", 
  RowBox[{"velvLoop", ".", "j"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    RowBox[{"Sin", "[", "\[Beta]", "]"}]}], " ", 
   RowBox[{
    SuperscriptBox["h", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"Cos", "[", 
    RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}], " ", 
   RowBox[{
    SuperscriptBox["\[Alpha]", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"Cos", "[", 
    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
   RowBox[{
    SuperscriptBox["\[Theta]", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}]}]], "Output",
 CellChangeTimes->{3.5184567088328*^9, 3.536265334681828*^9}]
}, Open  ]],

Cell["We can solve for the unknowns as follows.", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"solvel", "=", 
  RowBox[{"Solve", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Vxcomp", "==", "0"}], ",", 
      RowBox[{"Vycomp", "==", "0"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"h", "'"}], "[", "t", "]"}], ",", 
      RowBox[{
       RowBox[{"\[Alpha]", "'"}], "[", "t", "]"}]}], "}"}]}], 
   "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{
      SuperscriptBox["h", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
     RowBox[{"-", 
      FractionBox[
       RowBox[{"3", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", 
            RowBox[{"Cos", "[", 
             RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}], " ", 
           RowBox[{"Sin", "[", 
            RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}], " ", 
           RowBox[{
            SuperscriptBox["\[Theta]", "\[Prime]",
             MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{
           RowBox[{"Cos", "[", 
            RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}], " ", 
           RowBox[{"Sin", "[", 
            RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
           RowBox[{
            SuperscriptBox["\[Theta]", "\[Prime]",
             MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], 
       RowBox[{
        RowBox[{
         RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}]}], "+", 
        RowBox[{
         RowBox[{"Sin", "[", "\[Beta]", "]"}], " ", 
         RowBox[{"Sin", "[", 
          RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}]}]}]]}]}], ",", 
    RowBox[{
     RowBox[{
      SuperscriptBox["\[Alpha]", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
     FractionBox[
      RowBox[{"3", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
          RowBox[{"Cos", "[", 
           RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
          RowBox[{
           SuperscriptBox["\[Theta]", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
         RowBox[{
          RowBox[{"Sin", "[", "\[Beta]", "]"}], " ", 
          RowBox[{"Sin", "[", 
           RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
          RowBox[{
           SuperscriptBox["\[Theta]", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], 
      RowBox[{"2", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
          RowBox[{"Cos", "[", 
           RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}]}], "+", 
         RowBox[{
          RowBox[{"Sin", "[", "\[Beta]", "]"}], " ", 
          RowBox[{"Sin", "[", 
           RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}]}]}], ")"}]}]]}]}], 
   "}"}], "}"}]], "Output",
 CellChangeTimes->{3.518456709644*^9, 3.5362653347169247`*^9}]
}, Open  ]],

Cell["\<\
These substitution rules could be used to determine the second derviatives \
but we will use the vector loop one more time.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"velxLoop", "=", 
  RowBox[{"DvDt", "[", 
   RowBox[{"N", ",", "velvLoop"}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   OverscriptBox["\<\"j\"\>", "^"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       RowBox[{"Sin", "[", "\[Beta]", "]"}]}], " ", 
      RowBox[{
       SuperscriptBox["h", "\[Prime]\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}], "-", 
     RowBox[{"2", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Sin", "[", 
           RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}]}], " ", 
         SuperscriptBox[
          RowBox[{
           SuperscriptBox["\[Alpha]", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
        RowBox[{
         RowBox[{"Cos", "[", 
          RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}], " ", 
         RowBox[{
          SuperscriptBox["\[Alpha]", "\[Prime]\[Prime]",
           MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "+", 
     RowBox[{"3", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Sin", "[", 
           RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}], " ", 
         SuperscriptBox[
          RowBox[{
           SuperscriptBox["\[Theta]", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
        RowBox[{
         RowBox[{"Cos", "[", 
          RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
         RowBox[{
          SuperscriptBox["\[Theta]", "\[Prime]\[Prime]",
           MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}]}], ")"}]}], 
  "+", 
  RowBox[{
   OverscriptBox["\<\"i\"\>", "^"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       RowBox[{"Cos", "[", "\[Beta]", "]"}]}], " ", 
      RowBox[{
       SuperscriptBox["h", "\[Prime]\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}], "+", 
     RowBox[{"2", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"Cos", "[", 
          RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}], " ", 
         SuperscriptBox[
          RowBox[{
           SuperscriptBox["\[Alpha]", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
        RowBox[{
         RowBox[{"Sin", "[", 
          RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}], " ", 
         RowBox[{
          SuperscriptBox["\[Alpha]", "\[Prime]\[Prime]",
           MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "-", 
     RowBox[{"3", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"Cos", "[", 
          RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
         SuperscriptBox[
          RowBox[{
           SuperscriptBox["\[Theta]", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
        RowBox[{
         RowBox[{"Sin", "[", 
          RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
         RowBox[{
          SuperscriptBox["\[Theta]", "\[Prime]\[Prime]",
           MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{3.5184567114379997`*^9, 3.536265334749919*^9}]
}, Open  ]],

Cell["\<\
Which is equal to zero, but we hold that for now. We now need to set up \
equations to relate second derivatives.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Xxcomp", "=", 
  RowBox[{"velxLoop", " ", ".", "i"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    RowBox[{"Cos", "[", "\[Beta]", "]"}]}], " ", 
   RowBox[{
    SuperscriptBox["h", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "+", 
  RowBox[{"2", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"Cos", "[", 
       RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}], " ", 
      SuperscriptBox[
       RowBox[{
        SuperscriptBox["\[Alpha]", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
     RowBox[{
      RowBox[{"Sin", "[", 
       RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}], " ", 
      RowBox[{
       SuperscriptBox["\[Alpha]", "\[Prime]\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"Cos", "[", 
       RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
      SuperscriptBox[
       RowBox[{
        SuperscriptBox["\[Theta]", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
     RowBox[{
      RowBox[{"Sin", "[", 
       RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
      RowBox[{
       SuperscriptBox["\[Theta]", "\[Prime]\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.518456712296*^9, 3.53626533478207*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Xycomp", "=", 
  RowBox[{"velxLoop", ".", "j"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    RowBox[{"Sin", "[", "\[Beta]", "]"}]}], " ", 
   RowBox[{
    SuperscriptBox["h", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       RowBox[{"Sin", "[", 
        RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}]}], " ", 
      SuperscriptBox[
       RowBox[{
        SuperscriptBox["\[Alpha]", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
     RowBox[{
      RowBox[{"Cos", "[", 
       RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}], " ", 
      RowBox[{
       SuperscriptBox["\[Alpha]", "\[Prime]\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       RowBox[{"Sin", "[", 
        RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}], " ", 
      SuperscriptBox[
       RowBox[{
        SuperscriptBox["\[Theta]", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
     RowBox[{
      RowBox[{"Cos", "[", 
       RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
      RowBox[{
       SuperscriptBox["\[Theta]", "\[Prime]\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.518456712998*^9, 3.536265334816408*^9}]
}, Open  ]],

Cell["We can solve for the unknowns as follows.", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"solacc", "=", 
  RowBox[{"Solve", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Xxcomp", "==", "0"}], ",", 
      RowBox[{"Xycomp", "==", "0"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"h", "'"}], "'"}], "[", "t", "]"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"\[Alpha]", "'"}], "'"}], "[", "t", "]"}]}], "}"}]}], 
   "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{
      SuperscriptBox["h", "\[Prime]\[Prime]",
       MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
     RowBox[{"-", 
      FractionBox[
       RowBox[{
        RowBox[{
         RowBox[{"-", "2"}], " ", 
         SuperscriptBox[
          RowBox[{"Cos", "[", 
           RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}], "2"], " ", 
         SuperscriptBox[
          RowBox[{
           SuperscriptBox["\[Alpha]", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
        RowBox[{"2", " ", 
         SuperscriptBox[
          RowBox[{"Sin", "[", 
           RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}], "2"], " ", 
         SuperscriptBox[
          RowBox[{
           SuperscriptBox["\[Alpha]", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
        RowBox[{"3", " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}], " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
         SuperscriptBox[
          RowBox[{
           SuperscriptBox["\[Theta]", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
        RowBox[{"3", " ", 
         RowBox[{"Sin", "[", 
          RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}], " ", 
         RowBox[{"Sin", "[", 
          RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
         SuperscriptBox[
          RowBox[{
           SuperscriptBox["\[Theta]", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
        RowBox[{"3", " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
         RowBox[{"Sin", "[", 
          RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}], " ", 
         RowBox[{
          SuperscriptBox["\[Theta]", "\[Prime]\[Prime]",
           MultilineFunction->None], "[", "t", "]"}]}], "+", 
        RowBox[{"3", " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}], " ", 
         RowBox[{"Sin", "[", 
          RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
         RowBox[{
          SuperscriptBox["\[Theta]", "\[Prime]\[Prime]",
           MultilineFunction->None], "[", "t", "]"}]}]}], 
       RowBox[{
        RowBox[{
         RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}]}], "+", 
        RowBox[{
         RowBox[{"Sin", "[", "\[Beta]", "]"}], " ", 
         RowBox[{"Sin", "[", 
          RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}]}]}]]}]}], ",", 
    RowBox[{
     RowBox[{
      SuperscriptBox["\[Alpha]", "\[Prime]\[Prime]",
       MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
     RowBox[{"-", 
      FractionBox[
       RowBox[{
        RowBox[{"2", " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}], " ", 
         RowBox[{"Sin", "[", "\[Beta]", "]"}], " ", 
         SuperscriptBox[
          RowBox[{
           SuperscriptBox["\[Alpha]", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
        RowBox[{"2", " ", 
         RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
         RowBox[{"Sin", "[", 
          RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}], " ", 
         SuperscriptBox[
          RowBox[{
           SuperscriptBox["\[Alpha]", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
        RowBox[{"3", " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
         RowBox[{"Sin", "[", "\[Beta]", "]"}], " ", 
         SuperscriptBox[
          RowBox[{
           SuperscriptBox["\[Theta]", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
        RowBox[{"3", " ", 
         RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
         RowBox[{"Sin", "[", 
          RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
         SuperscriptBox[
          RowBox[{
           SuperscriptBox["\[Theta]", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
        RowBox[{"3", " ", 
         RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
         RowBox[{
          SuperscriptBox["\[Theta]", "\[Prime]\[Prime]",
           MultilineFunction->None], "[", "t", "]"}]}], "-", 
        RowBox[{"3", " ", 
         RowBox[{"Sin", "[", "\[Beta]", "]"}], " ", 
         RowBox[{"Sin", "[", 
          RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
         RowBox[{
          SuperscriptBox["\[Theta]", "\[Prime]\[Prime]",
           MultilineFunction->None], "[", "t", "]"}]}]}], 
       RowBox[{"2", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
           RowBox[{"Cos", "[", 
            RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}]}], "+", 
          RowBox[{
           RowBox[{"Sin", "[", "\[Beta]", "]"}], " ", 
           RowBox[{"Sin", "[", 
            RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}]}]}], ")"}]}]]}]}]}], 
   "}"}], "}"}]], "Output",
 CellChangeTimes->{3.518456713778*^9, 3.53626533487071*^9}]
}, Open  ]],

Cell["\<\
These velocity and acceleration terms can now be substituted into the velcity \
and acceleration terms above.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"avc", "=", 
  RowBox[{
   RowBox[{"avc", "//.", "solvel"}], "//", "First"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   OverscriptBox["\<\"j\"\>", "^"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"3", " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
      RowBox[{
       SuperscriptBox["\[Theta]", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}], "-", 
     FractionBox[
      RowBox[{"3", " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
          RowBox[{"Cos", "[", 
           RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
          RowBox[{
           SuperscriptBox["\[Theta]", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
         RowBox[{
          RowBox[{"Sin", "[", "\[Beta]", "]"}], " ", 
          RowBox[{"Sin", "[", 
           RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
          RowBox[{
           SuperscriptBox["\[Theta]", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], 
      RowBox[{
       RowBox[{
        RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
        RowBox[{"Cos", "[", 
         RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}]}], "+", 
       RowBox[{
        RowBox[{"Sin", "[", "\[Beta]", "]"}], " ", 
        RowBox[{"Sin", "[", 
         RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}]}]}]]}], ")"}]}], "+", 
  RowBox[{
   OverscriptBox["\<\"i\"\>", "^"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "3"}], " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
      RowBox[{
       SuperscriptBox["\[Theta]", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}], "+", 
     FractionBox[
      RowBox[{"3", " ", 
       RowBox[{"Sin", "[", 
        RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
          RowBox[{"Cos", "[", 
           RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
          RowBox[{
           SuperscriptBox["\[Theta]", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
         RowBox[{
          RowBox[{"Sin", "[", "\[Beta]", "]"}], " ", 
          RowBox[{"Sin", "[", 
           RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
          RowBox[{
           SuperscriptBox["\[Theta]", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], 
      RowBox[{
       RowBox[{
        RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
        RowBox[{"Cos", "[", 
         RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}]}], "+", 
       RowBox[{
        RowBox[{"Sin", "[", "\[Beta]", "]"}], " ", 
        RowBox[{"Sin", "[", 
         RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}]}]}]]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{3.5184567154784*^9, 3.536265334899308*^9}]
}, Open  ]],

Cell["\<\
Here we need to sub the velocirt solution after the acceleration solution \
because the acceleration term has first derivative terms in volved.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"axc", "=", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"axc", "//.", "solacc"}], "//.", "solvel"}], "//", "First"}], "//",
    "First"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   OverscriptBox["\<\"j\"\>", "^"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"3", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Sin", "[", 
           RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}], " ", 
         SuperscriptBox[
          RowBox[{
           SuperscriptBox["\[Theta]", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
        RowBox[{
         RowBox[{"Cos", "[", 
          RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
         RowBox[{
          SuperscriptBox["\[Theta]", "\[Prime]\[Prime]",
           MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "-", 
     RowBox[{"2", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"9", " ", 
           RowBox[{"Sin", "[", 
            RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
               RowBox[{"Cos", "[", 
                RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
               RowBox[{
                SuperscriptBox["\[Theta]", "\[Prime]",
                 MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{
               RowBox[{"Sin", "[", "\[Beta]", "]"}], " ", 
               RowBox[{"Sin", "[", 
                RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
               RowBox[{
                SuperscriptBox["\[Theta]", "\[Prime]",
                 MultilineFunction->None], "[", "t", "]"}]}]}], ")"}], "2"]}], 
          RowBox[{"4", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
               RowBox[{"Cos", "[", 
                RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}]}], "+", 
              RowBox[{
               RowBox[{"Sin", "[", "\[Beta]", "]"}], " ", 
               RowBox[{"Sin", "[", 
                RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}]}]}], ")"}], 
            "2"]}]]}], "-", 
        RowBox[{
         FractionBox["1", 
          RowBox[{"2", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
              RowBox[{"Cos", "[", 
               RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}]}], "+", 
             RowBox[{
              RowBox[{"Sin", "[", "\[Beta]", "]"}], " ", 
              RowBox[{"Sin", "[", 
               RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}]}]}], ")"}]}]], 
         RowBox[{
          RowBox[{"Cos", "[", 
           RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "3"}], " ", 
             RowBox[{"Cos", "[", 
              RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
             RowBox[{"Sin", "[", "\[Beta]", "]"}], " ", 
             SuperscriptBox[
              RowBox[{
               SuperscriptBox["\[Theta]", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
            RowBox[{"3", " ", 
             RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
             RowBox[{"Sin", "[", 
              RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
             SuperscriptBox[
              RowBox[{
               SuperscriptBox["\[Theta]", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
            FractionBox[
             RowBox[{"9", " ", 
              RowBox[{"Cos", "[", 
               RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}], " ", 
              RowBox[{"Sin", "[", "\[Beta]", "]"}], " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
                  RowBox[{"Cos", "[", 
                   RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox["\[Theta]", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
                 RowBox[{
                  RowBox[{"Sin", "[", "\[Beta]", "]"}], " ", 
                  RowBox[{"Sin", "[", 
                   RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox["\[Theta]", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}]}]}], ")"}], 
               "2"]}], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
                  RowBox[{"Cos", "[", 
                   RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}]}], "+", 
                 RowBox[{
                  RowBox[{"Sin", "[", "\[Beta]", "]"}], " ", 
                  RowBox[{"Sin", "[", 
                   RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}]}]}], ")"}], 
               "2"]}]], "-", 
            FractionBox[
             RowBox[{"9", " ", 
              RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
              RowBox[{"Sin", "[", 
               RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}], " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
                  RowBox[{"Cos", "[", 
                   RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox["\[Theta]", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
                 RowBox[{
                  RowBox[{"Sin", "[", "\[Beta]", "]"}], " ", 
                  RowBox[{"Sin", "[", 
                   RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox["\[Theta]", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}]}]}], ")"}], 
               "2"]}], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
                  RowBox[{"Cos", "[", 
                   RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}]}], "+", 
                 RowBox[{
                  RowBox[{"Sin", "[", "\[Beta]", "]"}], " ", 
                  RowBox[{"Sin", "[", 
                   RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}]}]}], ")"}], 
               "2"]}]], "-", 
            RowBox[{"3", " ", 
             RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
             RowBox[{"Cos", "[", 
              RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
             RowBox[{
              SuperscriptBox["\[Theta]", "\[Prime]\[Prime]",
               MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{"3", " ", 
             RowBox[{"Sin", "[", "\[Beta]", "]"}], " ", 
             RowBox[{"Sin", "[", 
              RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
             RowBox[{
              SuperscriptBox["\[Theta]", "\[Prime]\[Prime]",
               MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}]}]}], 
       ")"}]}]}], ")"}]}], "+", 
  RowBox[{
   OverscriptBox["\<\"i\"\>", "^"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "3"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"Cos", "[", 
          RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
         SuperscriptBox[
          RowBox[{
           SuperscriptBox["\[Theta]", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
        RowBox[{
         RowBox[{"Sin", "[", 
          RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
         RowBox[{
          SuperscriptBox["\[Theta]", "\[Prime]\[Prime]",
           MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "+", 
     RowBox[{"2", " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{"9", " ", 
          RowBox[{"Cos", "[", 
           RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
              RowBox[{"Cos", "[", 
               RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
              RowBox[{
               SuperscriptBox["\[Theta]", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
             RowBox[{
              RowBox[{"Sin", "[", "\[Beta]", "]"}], " ", 
              RowBox[{"Sin", "[", 
               RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
              RowBox[{
               SuperscriptBox["\[Theta]", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}]}], ")"}], "2"]}], 
         
         RowBox[{"4", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
              RowBox[{"Cos", "[", 
               RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}]}], "+", 
             RowBox[{
              RowBox[{"Sin", "[", "\[Beta]", "]"}], " ", 
              RowBox[{"Sin", "[", 
               RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}]}]}], ")"}], "2"]}]],
         "-", 
        RowBox[{
         FractionBox["1", 
          RowBox[{"2", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
              RowBox[{"Cos", "[", 
               RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}]}], "+", 
             RowBox[{
              RowBox[{"Sin", "[", "\[Beta]", "]"}], " ", 
              RowBox[{"Sin", "[", 
               RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}]}]}], ")"}]}]], 
         RowBox[{
          RowBox[{"Sin", "[", 
           RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "3"}], " ", 
             RowBox[{"Cos", "[", 
              RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
             RowBox[{"Sin", "[", "\[Beta]", "]"}], " ", 
             SuperscriptBox[
              RowBox[{
               SuperscriptBox["\[Theta]", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
            RowBox[{"3", " ", 
             RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
             RowBox[{"Sin", "[", 
              RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
             SuperscriptBox[
              RowBox[{
               SuperscriptBox["\[Theta]", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
            FractionBox[
             RowBox[{"9", " ", 
              RowBox[{"Cos", "[", 
               RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}], " ", 
              RowBox[{"Sin", "[", "\[Beta]", "]"}], " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
                  RowBox[{"Cos", "[", 
                   RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox["\[Theta]", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
                 RowBox[{
                  RowBox[{"Sin", "[", "\[Beta]", "]"}], " ", 
                  RowBox[{"Sin", "[", 
                   RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox["\[Theta]", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}]}]}], ")"}], 
               "2"]}], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
                  RowBox[{"Cos", "[", 
                   RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}]}], "+", 
                 RowBox[{
                  RowBox[{"Sin", "[", "\[Beta]", "]"}], " ", 
                  RowBox[{"Sin", "[", 
                   RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}]}]}], ")"}], 
               "2"]}]], "-", 
            FractionBox[
             RowBox[{"9", " ", 
              RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
              RowBox[{"Sin", "[", 
               RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}], " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
                  RowBox[{"Cos", "[", 
                   RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox["\[Theta]", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
                 RowBox[{
                  RowBox[{"Sin", "[", "\[Beta]", "]"}], " ", 
                  RowBox[{"Sin", "[", 
                   RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox["\[Theta]", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}]}]}], ")"}], 
               "2"]}], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
                  RowBox[{"Cos", "[", 
                   RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}]}], "+", 
                 RowBox[{
                  RowBox[{"Sin", "[", "\[Beta]", "]"}], " ", 
                  RowBox[{"Sin", "[", 
                   RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}]}]}], ")"}], 
               "2"]}]], "-", 
            RowBox[{"3", " ", 
             RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
             RowBox[{"Cos", "[", 
              RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
             RowBox[{
              SuperscriptBox["\[Theta]", "\[Prime]\[Prime]",
               MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{"3", " ", 
             RowBox[{"Sin", "[", "\[Beta]", "]"}], " ", 
             RowBox[{"Sin", "[", 
              RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
             RowBox[{
              SuperscriptBox["\[Theta]", "\[Prime]\[Prime]",
               MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}]}]}], 
       ")"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.5184567168356*^9, 3.536265334940111*^9}]
}, Open  ]],

Cell["\<\
Now we can plot the results.  We will plot the magnitude of the velocity and \
accleration for a simple funtion for \[Theta].  First we will net to get \
\[Alpha] from the vector loop as in another example.\
\>", "Text"],

Cell["The x and y components of the vector loop equation are:", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Xcomp", "=", 
  RowBox[{"vLoop", " ", ".", "i"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "3"}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"Cos", "[", 
    RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"Cos", "[", 
    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}], "-", 
  RowBox[{
   RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
   RowBox[{"h", "[", "t", "]"}]}]}]], "Output",
 CellChangeTimes->{3.5184567186296*^9, 3.536265334982272*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Ycomp", "=", 
  RowBox[{"vLoop", ".", "j"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    RowBox[{"h", "[", "t", "]"}]}], " ", 
   RowBox[{"Sin", "[", "\[Beta]", "]"}]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"Sin", "[", 
    RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"Sin", "[", 
    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}]}]], "Output",
 CellChangeTimes->{3.5184567202363997`*^9, 3.536265335015785*^9}]
}, Open  ]],

Cell["We can solve for \[Alpha] as follows.", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"elim1", "=", 
  RowBox[{"Eliminate", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Xcomp", "==", "0"}], ",", 
      RowBox[{"Ycomp", "==", "0"}]}], "}"}], ",", 
    RowBox[{"h", "[", "t", "]"}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"-", "3"}], " ", 
    RowBox[{"Sin", "[", "\[Beta]", "]"}]}], "+", 
   RowBox[{"3", " ", 
    RowBox[{"Cos", "[", 
     RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
    RowBox[{"Sin", "[", "\[Beta]", "]"}]}], "+", 
   RowBox[{"2", " ", 
    RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
    RowBox[{"Sin", "[", 
     RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}]}], "-", 
   RowBox[{"3", " ", 
    RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
    RowBox[{"Sin", "[", 
     RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}]}], "\[Equal]", 
  RowBox[{"2", " ", 
   RowBox[{"Cos", "[", 
    RowBox[{"\[Alpha]", "[", "t", "]"}], "]"}], " ", 
   RowBox[{"Sin", "[", "\[Beta]", "]"}]}]}]], "Output",
 CellChangeTimes->{3.518456721032*^9, 3.5362653350489407`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"solalpha", "=", 
  RowBox[{
   RowBox[{"Solve", "[", 
    RowBox[{"elim1", ",", 
     RowBox[{"\[Alpha]", "[", "t", "]"}]}], "]"}], "//", 
   "Simplify"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\[Alpha]", "[", "t", "]"}], "\[Rule]", 
     RowBox[{"-", 
      RowBox[{"ArcCos", "[", 
       RowBox[{
        FractionBox["1", "8"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "6"}], "+", 
          RowBox[{"6", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "-", 
          RowBox[{"6", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{
             RowBox[{"2", " ", "\[Beta]"}], "-", 
             RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
          RowBox[{"6", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}], "-", 
          RowBox[{"2", " ", 
           SqrtBox["2"], " ", 
           SqrtBox[
            RowBox[{
             SuperscriptBox[
              RowBox[{"Cos", "[", "\[Beta]", "]"}], "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "10"}], "+", 
               RowBox[{"9", " ", 
                RowBox[{"Cos", "[", 
                 RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "+", 
               RowBox[{"9", " ", 
                RowBox[{"Cos", "[", 
                 RowBox[{"2", " ", 
                  RowBox[{"(", 
                   RowBox[{"\[Beta]", "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], ")"}]}], "]"}]}], 
               "-", 
               RowBox[{"18", " ", 
                RowBox[{"Cos", "[", 
                 RowBox[{
                  RowBox[{"2", " ", "\[Beta]"}], "-", 
                  RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
               RowBox[{"18", " ", 
                RowBox[{"Cos", "[", 
                 RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}]}], ")"}]}]]}]}],
          ")"}]}], "]"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\[Alpha]", "[", "t", "]"}], "\[Rule]", 
     RowBox[{"ArcCos", "[", 
      RowBox[{
       FractionBox["1", "8"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "6"}], "+", 
         RowBox[{"6", " ", 
          RowBox[{"Cos", "[", 
           RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "-", 
         RowBox[{"6", " ", 
          RowBox[{"Cos", "[", 
           RowBox[{
            RowBox[{"2", " ", "\[Beta]"}], "-", 
            RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
         RowBox[{"6", " ", 
          RowBox[{"Cos", "[", 
           RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}], "-", 
         RowBox[{"2", " ", 
          SqrtBox["2"], " ", 
          SqrtBox[
           RowBox[{
            SuperscriptBox[
             RowBox[{"Cos", "[", "\[Beta]", "]"}], "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "10"}], "+", 
              RowBox[{"9", " ", 
               RowBox[{"Cos", "[", 
                RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "+", 
              RowBox[{"9", " ", 
               RowBox[{"Cos", "[", 
                RowBox[{"2", " ", 
                 RowBox[{"(", 
                  RowBox[{"\[Beta]", "-", 
                   RowBox[{"\[Theta]", "[", "t", "]"}]}], ")"}]}], "]"}]}], 
              "-", 
              RowBox[{"18", " ", 
               RowBox[{"Cos", "[", 
                RowBox[{
                 RowBox[{"2", " ", "\[Beta]"}], "-", 
                 RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
              RowBox[{"18", " ", 
               RowBox[{"Cos", "[", 
                RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}]}], ")"}]}]]}]}], 
        ")"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\[Alpha]", "[", "t", "]"}], "\[Rule]", 
     RowBox[{"-", 
      RowBox[{"ArcCos", "[", 
       RowBox[{
        FractionBox["1", "4"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "3"}], "+", 
          RowBox[{"3", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "-", 
          RowBox[{"3", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{
             RowBox[{"2", " ", "\[Beta]"}], "-", 
             RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
          RowBox[{"3", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}], "+", 
          RowBox[{
           SqrtBox["2"], " ", 
           SqrtBox[
            RowBox[{
             SuperscriptBox[
              RowBox[{"Cos", "[", "\[Beta]", "]"}], "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "10"}], "+", 
               RowBox[{"9", " ", 
                RowBox[{"Cos", "[", 
                 RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "+", 
               RowBox[{"9", " ", 
                RowBox[{"Cos", "[", 
                 RowBox[{"2", " ", 
                  RowBox[{"(", 
                   RowBox[{"\[Beta]", "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], ")"}]}], "]"}]}], 
               "-", 
               RowBox[{"18", " ", 
                RowBox[{"Cos", "[", 
                 RowBox[{
                  RowBox[{"2", " ", "\[Beta]"}], "-", 
                  RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
               RowBox[{"18", " ", 
                RowBox[{"Cos", "[", 
                 RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}]}], ")"}]}]]}]}],
          ")"}]}], "]"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\[Alpha]", "[", "t", "]"}], "\[Rule]", 
     RowBox[{"ArcCos", "[", 
      RowBox[{
       FractionBox["1", "4"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "3"}], "+", 
         RowBox[{"3", " ", 
          RowBox[{"Cos", "[", 
           RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "-", 
         RowBox[{"3", " ", 
          RowBox[{"Cos", "[", 
           RowBox[{
            RowBox[{"2", " ", "\[Beta]"}], "-", 
            RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
         RowBox[{"3", " ", 
          RowBox[{"Cos", "[", 
           RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}], "+", 
         RowBox[{
          SqrtBox["2"], " ", 
          SqrtBox[
           RowBox[{
            SuperscriptBox[
             RowBox[{"Cos", "[", "\[Beta]", "]"}], "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "10"}], "+", 
              RowBox[{"9", " ", 
               RowBox[{"Cos", "[", 
                RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "+", 
              RowBox[{"9", " ", 
               RowBox[{"Cos", "[", 
                RowBox[{"2", " ", 
                 RowBox[{"(", 
                  RowBox[{"\[Beta]", "-", 
                   RowBox[{"\[Theta]", "[", "t", "]"}]}], ")"}]}], "]"}]}], 
              "-", 
              RowBox[{"18", " ", 
               RowBox[{"Cos", "[", 
                RowBox[{
                 RowBox[{"2", " ", "\[Beta]"}], "-", 
                 RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
              RowBox[{"18", " ", 
               RowBox[{"Cos", "[", 
                RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}]}], ")"}]}]]}]}], 
        ")"}]}], "]"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.5184567221396*^9, 3.536265335940851*^9}]
}, Open  ]],

Cell["\<\
Now for the plotting.  There will be plots for each of the possible solutions \
for \[Alpha] above.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Vmag", "=", 
  RowBox[{
   RowBox[{"Sqrt", "[", 
    RowBox[{"avc", ".", "avc"}], "]"}], "//.", "solalpha"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"\[Sqrt]", 
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"3", " ", 
          RowBox[{"Cos", "[", 
           RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
          RowBox[{
           SuperscriptBox["\[Theta]", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "6"}], "+", 
              RowBox[{"6", " ", 
               RowBox[{"Cos", "[", 
                RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "-", 
              RowBox[{"6", " ", 
               RowBox[{"Cos", "[", 
                RowBox[{
                 RowBox[{"2", " ", "\[Beta]"}], "-", 
                 RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
              RowBox[{"6", " ", 
               RowBox[{"Cos", "[", 
                RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}], "-", 
              RowBox[{"2", " ", 
               SqrtBox["2"], " ", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"Cos", "[", "\[Beta]", "]"}], "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", "10"}], "+", 
                   RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "+", 
                   RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{"\[Beta]", "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], ")"}]}], "]"}]}], 
                   "-", 
                   RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{
                    RowBox[{"2", " ", "\[Beta]"}], "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
                   RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}]}], 
                  ")"}]}]]}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
               RowBox[{"Cos", "[", 
                RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
               RowBox[{
                SuperscriptBox["\[Theta]", "\[Prime]",
                 MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{
               RowBox[{"Sin", "[", "\[Beta]", "]"}], " ", 
               RowBox[{"Sin", "[", 
                RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
               RowBox[{
                SuperscriptBox["\[Theta]", "\[Prime]",
                 MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], 
           ")"}], "/", 
          RowBox[{"(", 
           RowBox[{"8", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               FractionBox["1", "8"], " ", 
               RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", "6"}], "+", 
                 RowBox[{"6", " ", 
                  RowBox[{"Cos", "[", 
                   RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "-", 
                 RowBox[{"6", " ", 
                  RowBox[{"Cos", "[", 
                   RowBox[{
                    RowBox[{"2", " ", "\[Beta]"}], "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
                 RowBox[{"6", " ", 
                  RowBox[{"Cos", "[", 
                   RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}], "-", 
                 RowBox[{"2", " ", 
                  SqrtBox["2"], " ", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox[
                    RowBox[{"Cos", "[", "\[Beta]", "]"}], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "10"}], "+", 
                    RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "+", 
                    RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{"\[Beta]", "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], ")"}]}], "]"}]}], 
                    "-", 
                    RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{
                    RowBox[{"2", " ", "\[Beta]"}], "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
                    RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}]}], 
                    ")"}]}]]}]}], ")"}]}], "-", 
              RowBox[{
               SqrtBox[
                RowBox[{"1", "-", 
                 RowBox[{
                  FractionBox["1", "64"], " ", 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "6"}], "+", 
                    RowBox[{"6", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "-", 
                    RowBox[{"6", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{
                    RowBox[{"2", " ", "\[Beta]"}], "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
                    RowBox[{"6", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    SqrtBox["2"], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{"Cos", "[", "\[Beta]", "]"}], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "10"}], "+", 
                    RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "+", 
                    RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{"\[Beta]", "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], ")"}]}], "]"}]}], 
                    "-", 
                    RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{
                    RowBox[{"2", " ", "\[Beta]"}], "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
                    RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}]}], 
                    ")"}]}]]}]}], ")"}], "2"]}]}]], " ", 
               RowBox[{"Sin", "[", "\[Beta]", "]"}]}]}], ")"}]}], ")"}]}]}], 
        ")"}], "2"], "+", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "3"}], " ", 
          RowBox[{"Sin", "[", 
           RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
          RowBox[{
           SuperscriptBox["\[Theta]", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"3", " ", 
            SqrtBox[
             RowBox[{"1", "-", 
              RowBox[{
               FractionBox["1", "64"], " ", 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "6"}], "+", 
                  RowBox[{"6", " ", 
                   RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "-", 
                  RowBox[{"6", " ", 
                   RowBox[{"Cos", "[", 
                    RowBox[{
                    RowBox[{"2", " ", "\[Beta]"}], "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
                  RowBox[{"6", " ", 
                   RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}], "-", 
                  RowBox[{"2", " ", 
                   SqrtBox["2"], " ", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{"Cos", "[", "\[Beta]", "]"}], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "10"}], "+", 
                    RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "+", 
                    RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{"\[Beta]", "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], ")"}]}], "]"}]}], 
                    "-", 
                    RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{
                    RowBox[{"2", " ", "\[Beta]"}], "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
                    RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}]}], 
                    ")"}]}]]}]}], ")"}], "2"]}]}]], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
               RowBox[{"Cos", "[", 
                RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
               RowBox[{
                SuperscriptBox["\[Theta]", "\[Prime]",
                 MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{
               RowBox[{"Sin", "[", "\[Beta]", "]"}], " ", 
               RowBox[{"Sin", "[", 
                RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
               RowBox[{
                SuperscriptBox["\[Theta]", "\[Prime]",
                 MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], 
           ")"}], "/", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             FractionBox["1", "8"], " ", 
             RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "6"}], "+", 
               RowBox[{"6", " ", 
                RowBox[{"Cos", "[", 
                 RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "-", 
               RowBox[{"6", " ", 
                RowBox[{"Cos", "[", 
                 RowBox[{
                  RowBox[{"2", " ", "\[Beta]"}], "-", 
                  RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
               RowBox[{"6", " ", 
                RowBox[{"Cos", "[", 
                 RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}], "-", 
               RowBox[{"2", " ", 
                SqrtBox["2"], " ", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"Cos", "[", "\[Beta]", "]"}], "2"], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", "10"}], "+", 
                    RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "+", 
                    RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{"\[Beta]", "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], ")"}]}], "]"}]}], 
                    "-", 
                    RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{
                    RowBox[{"2", " ", "\[Beta]"}], "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
                    RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}]}], 
                   ")"}]}]]}]}], ")"}]}], "-", 
            RowBox[{
             SqrtBox[
              RowBox[{"1", "-", 
               RowBox[{
                FractionBox["1", "64"], " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", "6"}], "+", 
                   RowBox[{"6", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "-", 
                   RowBox[{"6", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{
                    RowBox[{"2", " ", "\[Beta]"}], "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
                   RowBox[{"6", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}], "-", 
                   RowBox[{"2", " ", 
                    SqrtBox["2"], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{"Cos", "[", "\[Beta]", "]"}], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "10"}], "+", 
                    RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "+", 
                    RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{"\[Beta]", "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], ")"}]}], "]"}]}], 
                    "-", 
                    RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{
                    RowBox[{"2", " ", "\[Beta]"}], "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
                    RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}]}], 
                    ")"}]}]]}]}], ")"}], "2"]}]}]], " ", 
             RowBox[{"Sin", "[", "\[Beta]", "]"}]}]}], ")"}]}]}], ")"}], 
       "2"]}], ")"}]}], ",", 
   RowBox[{"\[Sqrt]", 
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"3", " ", 
          RowBox[{"Cos", "[", 
           RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
          RowBox[{
           SuperscriptBox["\[Theta]", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "6"}], "+", 
              RowBox[{"6", " ", 
               RowBox[{"Cos", "[", 
                RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "-", 
              RowBox[{"6", " ", 
               RowBox[{"Cos", "[", 
                RowBox[{
                 RowBox[{"2", " ", "\[Beta]"}], "-", 
                 RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
              RowBox[{"6", " ", 
               RowBox[{"Cos", "[", 
                RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}], "-", 
              RowBox[{"2", " ", 
               SqrtBox["2"], " ", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"Cos", "[", "\[Beta]", "]"}], "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", "10"}], "+", 
                   RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "+", 
                   RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{"\[Beta]", "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], ")"}]}], "]"}]}], 
                   "-", 
                   RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{
                    RowBox[{"2", " ", "\[Beta]"}], "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
                   RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}]}], 
                  ")"}]}]]}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
               RowBox[{"Cos", "[", 
                RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
               RowBox[{
                SuperscriptBox["\[Theta]", "\[Prime]",
                 MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{
               RowBox[{"Sin", "[", "\[Beta]", "]"}], " ", 
               RowBox[{"Sin", "[", 
                RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
               RowBox[{
                SuperscriptBox["\[Theta]", "\[Prime]",
                 MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], 
           ")"}], "/", 
          RowBox[{"(", 
           RowBox[{"8", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               FractionBox["1", "8"], " ", 
               RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", "6"}], "+", 
                 RowBox[{"6", " ", 
                  RowBox[{"Cos", "[", 
                   RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "-", 
                 RowBox[{"6", " ", 
                  RowBox[{"Cos", "[", 
                   RowBox[{
                    RowBox[{"2", " ", "\[Beta]"}], "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
                 RowBox[{"6", " ", 
                  RowBox[{"Cos", "[", 
                   RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}], "-", 
                 RowBox[{"2", " ", 
                  SqrtBox["2"], " ", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox[
                    RowBox[{"Cos", "[", "\[Beta]", "]"}], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "10"}], "+", 
                    RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "+", 
                    RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{"\[Beta]", "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], ")"}]}], "]"}]}], 
                    "-", 
                    RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{
                    RowBox[{"2", " ", "\[Beta]"}], "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
                    RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}]}], 
                    ")"}]}]]}]}], ")"}]}], "+", 
              RowBox[{
               SqrtBox[
                RowBox[{"1", "-", 
                 RowBox[{
                  FractionBox["1", "64"], " ", 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "6"}], "+", 
                    RowBox[{"6", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "-", 
                    RowBox[{"6", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{
                    RowBox[{"2", " ", "\[Beta]"}], "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
                    RowBox[{"6", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    SqrtBox["2"], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{"Cos", "[", "\[Beta]", "]"}], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "10"}], "+", 
                    RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "+", 
                    RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{"\[Beta]", "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], ")"}]}], "]"}]}], 
                    "-", 
                    RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{
                    RowBox[{"2", " ", "\[Beta]"}], "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
                    RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}]}], 
                    ")"}]}]]}]}], ")"}], "2"]}]}]], " ", 
               RowBox[{"Sin", "[", "\[Beta]", "]"}]}]}], ")"}]}], ")"}]}]}], 
        ")"}], "2"], "+", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "3"}], " ", 
          RowBox[{"Sin", "[", 
           RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
          RowBox[{
           SuperscriptBox["\[Theta]", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"3", " ", 
            SqrtBox[
             RowBox[{"1", "-", 
              RowBox[{
               FractionBox["1", "64"], " ", 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "6"}], "+", 
                  RowBox[{"6", " ", 
                   RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "-", 
                  RowBox[{"6", " ", 
                   RowBox[{"Cos", "[", 
                    RowBox[{
                    RowBox[{"2", " ", "\[Beta]"}], "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
                  RowBox[{"6", " ", 
                   RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}], "-", 
                  RowBox[{"2", " ", 
                   SqrtBox["2"], " ", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{"Cos", "[", "\[Beta]", "]"}], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "10"}], "+", 
                    RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "+", 
                    RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{"\[Beta]", "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], ")"}]}], "]"}]}], 
                    "-", 
                    RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{
                    RowBox[{"2", " ", "\[Beta]"}], "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
                    RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}]}], 
                    ")"}]}]]}]}], ")"}], "2"]}]}]], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
               RowBox[{"Cos", "[", 
                RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
               RowBox[{
                SuperscriptBox["\[Theta]", "\[Prime]",
                 MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{
               RowBox[{"Sin", "[", "\[Beta]", "]"}], " ", 
               RowBox[{"Sin", "[", 
                RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
               RowBox[{
                SuperscriptBox["\[Theta]", "\[Prime]",
                 MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], 
           ")"}], "/", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             FractionBox["1", "8"], " ", 
             RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "6"}], "+", 
               RowBox[{"6", " ", 
                RowBox[{"Cos", "[", 
                 RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "-", 
               RowBox[{"6", " ", 
                RowBox[{"Cos", "[", 
                 RowBox[{
                  RowBox[{"2", " ", "\[Beta]"}], "-", 
                  RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
               RowBox[{"6", " ", 
                RowBox[{"Cos", "[", 
                 RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}], "-", 
               RowBox[{"2", " ", 
                SqrtBox["2"], " ", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"Cos", "[", "\[Beta]", "]"}], "2"], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", "10"}], "+", 
                    RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "+", 
                    RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{"\[Beta]", "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], ")"}]}], "]"}]}], 
                    "-", 
                    RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{
                    RowBox[{"2", " ", "\[Beta]"}], "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
                    RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}]}], 
                   ")"}]}]]}]}], ")"}]}], "+", 
            RowBox[{
             SqrtBox[
              RowBox[{"1", "-", 
               RowBox[{
                FractionBox["1", "64"], " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", "6"}], "+", 
                   RowBox[{"6", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "-", 
                   RowBox[{"6", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{
                    RowBox[{"2", " ", "\[Beta]"}], "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
                   RowBox[{"6", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}], "-", 
                   RowBox[{"2", " ", 
                    SqrtBox["2"], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{"Cos", "[", "\[Beta]", "]"}], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "10"}], "+", 
                    RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "+", 
                    RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{"\[Beta]", "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], ")"}]}], "]"}]}], 
                    "-", 
                    RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{
                    RowBox[{"2", " ", "\[Beta]"}], "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
                    RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}]}], 
                    ")"}]}]]}]}], ")"}], "2"]}]}]], " ", 
             RowBox[{"Sin", "[", "\[Beta]", "]"}]}]}], ")"}]}]}], ")"}], 
       "2"]}], ")"}]}], ",", 
   RowBox[{"\[Sqrt]", 
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"3", " ", 
          RowBox[{"Cos", "[", 
           RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
          RowBox[{
           SuperscriptBox["\[Theta]", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "3"}], "+", 
              RowBox[{"3", " ", 
               RowBox[{"Cos", "[", 
                RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "-", 
              RowBox[{"3", " ", 
               RowBox[{"Cos", "[", 
                RowBox[{
                 RowBox[{"2", " ", "\[Beta]"}], "-", 
                 RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
              RowBox[{"3", " ", 
               RowBox[{"Cos", "[", 
                RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}], "+", 
              RowBox[{
               SqrtBox["2"], " ", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"Cos", "[", "\[Beta]", "]"}], "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", "10"}], "+", 
                   RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "+", 
                   RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{"\[Beta]", "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], ")"}]}], "]"}]}], 
                   "-", 
                   RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{
                    RowBox[{"2", " ", "\[Beta]"}], "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
                   RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}]}], 
                  ")"}]}]]}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
               RowBox[{"Cos", "[", 
                RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
               RowBox[{
                SuperscriptBox["\[Theta]", "\[Prime]",
                 MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{
               RowBox[{"Sin", "[", "\[Beta]", "]"}], " ", 
               RowBox[{"Sin", "[", 
                RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
               RowBox[{
                SuperscriptBox["\[Theta]", "\[Prime]",
                 MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], 
           ")"}], "/", 
          RowBox[{"(", 
           RowBox[{"4", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               FractionBox["1", "4"], " ", 
               RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", "3"}], "+", 
                 RowBox[{"3", " ", 
                  RowBox[{"Cos", "[", 
                   RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "-", 
                 RowBox[{"3", " ", 
                  RowBox[{"Cos", "[", 
                   RowBox[{
                    RowBox[{"2", " ", "\[Beta]"}], "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
                 RowBox[{"3", " ", 
                  RowBox[{"Cos", "[", 
                   RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}], "+", 
                 RowBox[{
                  SqrtBox["2"], " ", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox[
                    RowBox[{"Cos", "[", "\[Beta]", "]"}], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "10"}], "+", 
                    RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "+", 
                    RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{"\[Beta]", "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], ")"}]}], "]"}]}], 
                    "-", 
                    RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{
                    RowBox[{"2", " ", "\[Beta]"}], "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
                    RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}]}], 
                    ")"}]}]]}]}], ")"}]}], "-", 
              RowBox[{
               SqrtBox[
                RowBox[{"1", "-", 
                 RowBox[{
                  FractionBox["1", "16"], " ", 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "3"}], "+", 
                    RowBox[{"3", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "-", 
                    RowBox[{"3", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{
                    RowBox[{"2", " ", "\[Beta]"}], "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
                    RowBox[{"3", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}], "+", 
                    RowBox[{
                    SqrtBox["2"], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{"Cos", "[", "\[Beta]", "]"}], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "10"}], "+", 
                    RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "+", 
                    RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{"\[Beta]", "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], ")"}]}], "]"}]}], 
                    "-", 
                    RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{
                    RowBox[{"2", " ", "\[Beta]"}], "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
                    RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}]}], 
                    ")"}]}]]}]}], ")"}], "2"]}]}]], " ", 
               RowBox[{"Sin", "[", "\[Beta]", "]"}]}]}], ")"}]}], ")"}]}]}], 
        ")"}], "2"], "+", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "3"}], " ", 
          RowBox[{"Sin", "[", 
           RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
          RowBox[{
           SuperscriptBox["\[Theta]", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"3", " ", 
            SqrtBox[
             RowBox[{"1", "-", 
              RowBox[{
               FractionBox["1", "16"], " ", 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "3"}], "+", 
                  RowBox[{"3", " ", 
                   RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "-", 
                  RowBox[{"3", " ", 
                   RowBox[{"Cos", "[", 
                    RowBox[{
                    RowBox[{"2", " ", "\[Beta]"}], "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
                  RowBox[{"3", " ", 
                   RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}], "+", 
                  RowBox[{
                   SqrtBox["2"], " ", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{"Cos", "[", "\[Beta]", "]"}], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "10"}], "+", 
                    RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "+", 
                    RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{"\[Beta]", "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], ")"}]}], "]"}]}], 
                    "-", 
                    RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{
                    RowBox[{"2", " ", "\[Beta]"}], "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
                    RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}]}], 
                    ")"}]}]]}]}], ")"}], "2"]}]}]], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
               RowBox[{"Cos", "[", 
                RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
               RowBox[{
                SuperscriptBox["\[Theta]", "\[Prime]",
                 MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{
               RowBox[{"Sin", "[", "\[Beta]", "]"}], " ", 
               RowBox[{"Sin", "[", 
                RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
               RowBox[{
                SuperscriptBox["\[Theta]", "\[Prime]",
                 MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], 
           ")"}], "/", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             FractionBox["1", "4"], " ", 
             RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "3"}], "+", 
               RowBox[{"3", " ", 
                RowBox[{"Cos", "[", 
                 RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "-", 
               RowBox[{"3", " ", 
                RowBox[{"Cos", "[", 
                 RowBox[{
                  RowBox[{"2", " ", "\[Beta]"}], "-", 
                  RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
               RowBox[{"3", " ", 
                RowBox[{"Cos", "[", 
                 RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}], "+", 
               RowBox[{
                SqrtBox["2"], " ", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"Cos", "[", "\[Beta]", "]"}], "2"], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", "10"}], "+", 
                    RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "+", 
                    RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{"\[Beta]", "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], ")"}]}], "]"}]}], 
                    "-", 
                    RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{
                    RowBox[{"2", " ", "\[Beta]"}], "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
                    RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}]}], 
                   ")"}]}]]}]}], ")"}]}], "-", 
            RowBox[{
             SqrtBox[
              RowBox[{"1", "-", 
               RowBox[{
                FractionBox["1", "16"], " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", "3"}], "+", 
                   RowBox[{"3", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "-", 
                   RowBox[{"3", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{
                    RowBox[{"2", " ", "\[Beta]"}], "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
                   RowBox[{"3", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}], "+", 
                   RowBox[{
                    SqrtBox["2"], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{"Cos", "[", "\[Beta]", "]"}], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "10"}], "+", 
                    RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "+", 
                    RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{"\[Beta]", "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], ")"}]}], "]"}]}], 
                    "-", 
                    RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{
                    RowBox[{"2", " ", "\[Beta]"}], "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
                    RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}]}], 
                    ")"}]}]]}]}], ")"}], "2"]}]}]], " ", 
             RowBox[{"Sin", "[", "\[Beta]", "]"}]}]}], ")"}]}]}], ")"}], 
       "2"]}], ")"}]}], ",", 
   RowBox[{"\[Sqrt]", 
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"3", " ", 
          RowBox[{"Cos", "[", 
           RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
          RowBox[{
           SuperscriptBox["\[Theta]", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "3"}], "+", 
              RowBox[{"3", " ", 
               RowBox[{"Cos", "[", 
                RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "-", 
              RowBox[{"3", " ", 
               RowBox[{"Cos", "[", 
                RowBox[{
                 RowBox[{"2", " ", "\[Beta]"}], "-", 
                 RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
              RowBox[{"3", " ", 
               RowBox[{"Cos", "[", 
                RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}], "+", 
              RowBox[{
               SqrtBox["2"], " ", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"Cos", "[", "\[Beta]", "]"}], "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", "10"}], "+", 
                   RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "+", 
                   RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{"\[Beta]", "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], ")"}]}], "]"}]}], 
                   "-", 
                   RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{
                    RowBox[{"2", " ", "\[Beta]"}], "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
                   RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}]}], 
                  ")"}]}]]}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
               RowBox[{"Cos", "[", 
                RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
               RowBox[{
                SuperscriptBox["\[Theta]", "\[Prime]",
                 MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{
               RowBox[{"Sin", "[", "\[Beta]", "]"}], " ", 
               RowBox[{"Sin", "[", 
                RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
               RowBox[{
                SuperscriptBox["\[Theta]", "\[Prime]",
                 MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], 
           ")"}], "/", 
          RowBox[{"(", 
           RowBox[{"4", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               FractionBox["1", "4"], " ", 
               RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", "3"}], "+", 
                 RowBox[{"3", " ", 
                  RowBox[{"Cos", "[", 
                   RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "-", 
                 RowBox[{"3", " ", 
                  RowBox[{"Cos", "[", 
                   RowBox[{
                    RowBox[{"2", " ", "\[Beta]"}], "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
                 RowBox[{"3", " ", 
                  RowBox[{"Cos", "[", 
                   RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}], "+", 
                 RowBox[{
                  SqrtBox["2"], " ", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox[
                    RowBox[{"Cos", "[", "\[Beta]", "]"}], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "10"}], "+", 
                    RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "+", 
                    RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{"\[Beta]", "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], ")"}]}], "]"}]}], 
                    "-", 
                    RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{
                    RowBox[{"2", " ", "\[Beta]"}], "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
                    RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}]}], 
                    ")"}]}]]}]}], ")"}]}], "+", 
              RowBox[{
               SqrtBox[
                RowBox[{"1", "-", 
                 RowBox[{
                  FractionBox["1", "16"], " ", 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "3"}], "+", 
                    RowBox[{"3", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "-", 
                    RowBox[{"3", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{
                    RowBox[{"2", " ", "\[Beta]"}], "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
                    RowBox[{"3", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}], "+", 
                    RowBox[{
                    SqrtBox["2"], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{"Cos", "[", "\[Beta]", "]"}], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "10"}], "+", 
                    RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "+", 
                    RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{"\[Beta]", "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], ")"}]}], "]"}]}], 
                    "-", 
                    RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{
                    RowBox[{"2", " ", "\[Beta]"}], "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
                    RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}]}], 
                    ")"}]}]]}]}], ")"}], "2"]}]}]], " ", 
               RowBox[{"Sin", "[", "\[Beta]", "]"}]}]}], ")"}]}], ")"}]}]}], 
        ")"}], "2"], "+", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "3"}], " ", 
          RowBox[{"Sin", "[", 
           RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
          RowBox[{
           SuperscriptBox["\[Theta]", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"3", " ", 
            SqrtBox[
             RowBox[{"1", "-", 
              RowBox[{
               FractionBox["1", "16"], " ", 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "3"}], "+", 
                  RowBox[{"3", " ", 
                   RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "-", 
                  RowBox[{"3", " ", 
                   RowBox[{"Cos", "[", 
                    RowBox[{
                    RowBox[{"2", " ", "\[Beta]"}], "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
                  RowBox[{"3", " ", 
                   RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}], "+", 
                  RowBox[{
                   SqrtBox["2"], " ", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{"Cos", "[", "\[Beta]", "]"}], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "10"}], "+", 
                    RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "+", 
                    RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{"\[Beta]", "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], ")"}]}], "]"}]}], 
                    "-", 
                    RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{
                    RowBox[{"2", " ", "\[Beta]"}], "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
                    RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}]}], 
                    ")"}]}]]}]}], ")"}], "2"]}]}]], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
               RowBox[{"Cos", "[", 
                RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
               RowBox[{
                SuperscriptBox["\[Theta]", "\[Prime]",
                 MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{
               RowBox[{"Sin", "[", "\[Beta]", "]"}], " ", 
               RowBox[{"Sin", "[", 
                RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
               RowBox[{
                SuperscriptBox["\[Theta]", "\[Prime]",
                 MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], 
           ")"}], "/", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             FractionBox["1", "4"], " ", 
             RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "3"}], "+", 
               RowBox[{"3", " ", 
                RowBox[{"Cos", "[", 
                 RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "-", 
               RowBox[{"3", " ", 
                RowBox[{"Cos", "[", 
                 RowBox[{
                  RowBox[{"2", " ", "\[Beta]"}], "-", 
                  RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
               RowBox[{"3", " ", 
                RowBox[{"Cos", "[", 
                 RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}], "+", 
               RowBox[{
                SqrtBox["2"], " ", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"Cos", "[", "\[Beta]", "]"}], "2"], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", "10"}], "+", 
                    RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "+", 
                    RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{"\[Beta]", "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], ")"}]}], "]"}]}], 
                    "-", 
                    RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{
                    RowBox[{"2", " ", "\[Beta]"}], "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
                    RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}]}], 
                   ")"}]}]]}]}], ")"}]}], "+", 
            RowBox[{
             SqrtBox[
              RowBox[{"1", "-", 
               RowBox[{
                FractionBox["1", "16"], " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", "3"}], "+", 
                   RowBox[{"3", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "-", 
                   RowBox[{"3", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{
                    RowBox[{"2", " ", "\[Beta]"}], "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
                   RowBox[{"3", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}], "+", 
                   RowBox[{
                    SqrtBox["2"], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{"Cos", "[", "\[Beta]", "]"}], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "10"}], "+", 
                    RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "+", 
                    RowBox[{"9", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{"\[Beta]", "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], ")"}]}], "]"}]}], 
                    "-", 
                    RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{
                    RowBox[{"2", " ", "\[Beta]"}], "-", 
                    RowBox[{"\[Theta]", "[", "t", "]"}]}], "]"}]}], "+", 
                    RowBox[{"18", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}]}], 
                    ")"}]}]]}]}], ")"}], "2"]}]}]], " ", 
             RowBox[{"Sin", "[", "\[Beta]", "]"}]}]}], ")"}]}]}], ")"}], 
       "2"]}], ")"}]}]}], "}"}]], "Output",
 CellChangeTimes->{3.5184567237932*^9, 3.536265336025329*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Xmag", "=", 
  RowBox[{
   RowBox[{"Sqrt", "[", 
    RowBox[{"axc", ".", "axc"}], "]"}], "//.", "solalpha"}]}]], "Input"],

Cell[BoxData[
 InterpretationBox[
  TagBox[
   PanelBox[GridBox[{
      {
       StyleBox[
        StyleBox[
         DynamicBox[ToBoxes[
           FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"], 
           StandardForm],
          ImageSizeCache->{278., {2., 8.}}],
         StripOnInput->False,
         DynamicUpdating->True], "Panel",
        StripOnInput->False,
        Background->None]},
      {
       ItemBox[
        TagBox[
         RowBox[{"{", 
          RowBox[{
           RowBox[{"\[Sqrt]", 
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"3", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox["\[Theta]", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox["\[Theta]", "\[Prime]\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], 
                 "-", 
                 RowBox[{"2", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    FractionBox[
                    RowBox[{"9", " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    RowBox[{
                    FractionBox["1", "64"], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "6"}], "+", 
                    RowBox[{"\[LeftSkeleton]", "6", "\[RightSkeleton]"}]}], 
                    ")"}], "2"]}]}]], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox["\[Theta]", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
                    RowBox[{
                    RowBox[{"Sin", "[", "\[Beta]", "]"}], " ", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox["\[Theta]", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}]}]}], ")"}], 
                    "2"]}], 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    FractionBox["1", "8"], " ", 
                    RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "6"}], "+", 
                    RowBox[{"\[LeftSkeleton]", "6", "\[RightSkeleton]"}]}], 
                    ")"}]}], "-", 
                    RowBox[{
                    SqrtBox[
                    RowBox[{"1", "-", 
                    RowBox[{
                    FractionBox["1", "64"], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], 
                    ")"}], "2"]}]}]], " ", 
                    RowBox[{"Sin", "[", "\[Beta]", "]"}]}]}], ")"}], "2"]}]], 
                    "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "6"}], "+", 
                    RowBox[{"\[LeftSkeleton]", "6", "\[RightSkeleton]"}]}], 
                    ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "3"}], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
                    RowBox[{"Sin", "[", "\[Beta]", "]"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox["\[Theta]", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
                    RowBox[{"\[LeftSkeleton]", "7", "\[RightSkeleton]"}]}], 
                    ")"}]}], 
                    RowBox[{"16", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    FractionBox["1", "8"], " ", 
                    RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "6"}], "+", 
                    RowBox[{"\[LeftSkeleton]", "6", "\[RightSkeleton]"}]}], 
                    ")"}]}], "-", 
                    RowBox[{
                    SqrtBox[
                    RowBox[{"1", "-", 
                    RowBox[{
                    FractionBox["1", "64"], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "6"}], "+", 
                    RowBox[{"\[LeftSkeleton]", "6", "\[RightSkeleton]"}]}], 
                    ")"}], "2"]}]}]], " ", 
                    RowBox[{"Sin", "[", "\[Beta]", "]"}]}]}], ")"}]}]]}], 
                   ")"}]}]}], ")"}], "2"], "+", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"-", "3"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox["\[Theta]", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
                    RowBox[{
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox["\[Theta]", "\[Prime]\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], 
                 "+", 
                 RowBox[{"2", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    FractionBox[
                    RowBox[{"9", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "6"}], "+", 
                    RowBox[{"\[LeftSkeleton]", "6", "\[RightSkeleton]"}]}], 
                    ")"}], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox["\[Theta]", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
                    RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}]}], 
                    ")"}], "2"]}], 
                    RowBox[{"32", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    FractionBox["1", "8"], " ", 
                    RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "6"}], "+", 
                    RowBox[{"\[LeftSkeleton]", "6", "\[RightSkeleton]"}]}], 
                    ")"}]}], "-", 
                    RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}]}], 
                    ")"}], "2"]}]], "+", 
                    FractionBox[
                    RowBox[{
                    SqrtBox[
                    RowBox[{"1", "-", 
                    RowBox[{
                    FractionBox["1", "64"], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], 
                    ")"}], "2"]}]}]], " ", 
                    RowBox[{"(", 
                    RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], 
                    ")"}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    FractionBox["1", "8"], " ", 
                    RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "6"}], "+", 
                    RowBox[{"\[LeftSkeleton]", "6", "\[RightSkeleton]"}]}], 
                    ")"}]}], "-", 
                    RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}]}], 
                    ")"}]}]]}], ")"}]}]}], ")"}], "2"]}], ")"}]}], ",", 
           SqrtBox[
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"3", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}], " ", 
                    RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}]}], 
                   "+", 
                   RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}]}], 
                  ")"}]}], "-", 
                RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}]}], ")"}],
               "2"], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", "3"}], " ", 
                 RowBox[{"(", 
                  RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], 
                  ")"}]}], "+", 
                RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}]}], ")"}],
               "2"]}]], ",", 
           SqrtBox[
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], ")"}], 
              "2"], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], 
               RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}]}], 
              "2"]}]], ",", 
           SqrtBox[
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"3", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}]}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox["\[Theta]", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
                   RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox["\[Theta]", "\[Prime]\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], 
                "-", 
                RowBox[{"2", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    FractionBox[
                    RowBox[{"9", " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    RowBox[{
                    FractionBox["1", 
                    RowBox[{"\[LeftSkeleton]", "2", "\[RightSkeleton]"}]], 
                    " ", 
                    RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}]}]}]],
                     " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], 
                    ")"}], "2"]}], 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], 
                    ")"}], "2"]}]]}], "-", 
                   FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], 
                    ")"}], 
                    RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], 
                    RowBox[{"(", 
                    RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], 
                    RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}]}]}], 
                    
                    RowBox[{"8", " ", 
                    RowBox[{"(", 
                    RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], 
                    ")"}]}]]}], ")"}]}]}], ")"}], "2"], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", "3"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox["\[Theta]", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
                   RowBox[{
                    RowBox[{"Sin", "[", 
                    RowBox[{"\[Theta]", "[", "t", "]"}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox["\[Theta]", "\[Prime]\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], 
                "+", 
                RowBox[{"2", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   FractionBox[
                    RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], 
                    RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}]], 
                   "-", 
                   RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}]}], 
                  ")"}]}]}], ")"}], "2"]}]]}], "}"}],
         Short[#, 5]& ],
        Background->GrayLevel[1],
        BaseStyle->{Deployed -> False},
        Frame->True,
        FrameStyle->GrayLevel[0, 0.2],
        StripOnInput->False]},
      {
       RowBox[{
        ButtonBox[
         StyleBox[
          StyleBox[
           DynamicBox[ToBoxes[
             FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
             StandardForm],
            ImageSizeCache->{49., {1., 8.}}],
           StripOnInput->False,
           DynamicUpdating->True], "Panel",
          StripOnInput->False,
          Background->None],
         Appearance->Automatic,
         ButtonFunction:>OutputSizeLimit`ButtonFunction[
          Identity, 25, 23175126939136870275, 5/2],
         Enabled->True,
         Evaluator->Automatic,
         Method->"Queued"], "\[ThinSpace]", 
        ButtonBox[
         StyleBox[
          StyleBox[
           DynamicBox[ToBoxes[
             FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
             StandardForm],
            ImageSizeCache->{52., {1., 8.}}],
           StripOnInput->False,
           DynamicUpdating->True], "Panel",
          StripOnInput->False,
          Background->None],
         Appearance->Automatic,
         ButtonFunction:>OutputSizeLimit`ButtonFunction[
          Identity, 25, 23175126939136870275, 5 2],
         Enabled->True,
         Evaluator->Automatic,
         Method->"Queued"], "\[ThinSpace]", 
        ButtonBox[
         StyleBox[
          StyleBox[
           DynamicBox[ToBoxes[
             FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
             StandardForm],
            ImageSizeCache->{82., {2., 8.}}],
           StripOnInput->False,
           DynamicUpdating->True], "Panel",
          StripOnInput->False,
          Background->None],
         Appearance->Automatic,
         ButtonFunction:>OutputSizeLimit`ButtonFunction[
          Identity, 25, 23175126939136870275, Infinity],
         Enabled->True,
         Evaluator->Automatic,
         Method->"Queued"], "\[ThinSpace]", 
        ButtonBox[
         StyleBox[
          StyleBox[
           DynamicBox[ToBoxes[
             FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
             StandardForm],
            ImageSizeCache->{74., {1., 8.}}],
           StripOnInput->False,
           DynamicUpdating->True], "Panel",
          StripOnInput->False,
          Background->None],
         Appearance->Automatic,
         ButtonFunction:>FrontEndExecute[{
            FrontEnd`SetOptions[
            FrontEnd`$FrontEnd, 
             FrontEnd`PreferencesSettings -> {"Page" -> "Evaluation"}], 
            FrontEnd`FrontEndToken["PreferencesDialog"]}],
         Evaluator->None,
         Method->"Preemptive"]}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {{False}}, "ColumnsIndexed" -> {}, "Rows" -> {{False}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[1.2]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    DefaultBaseStyle->{},
    FrameMargins->5],
   Deploy,
   DefaultBaseStyle->{Deployed -> True}],
  Out[25]]], "Output",
 CellChangeTimes->{3.5184567269288*^9, 3.5362653362333317`*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[Beta]", "=", 
   RowBox[{"Pi", "/", "6"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"\[Theta]", "[", "t_", "]"}], ":=", 
  RowBox[{
   RowBox[{"11", " ", 
    RowBox[{"Pi", "/", "6"}], " ", "t"}], " ", "-", 
   RowBox[{"3", " ", 
    RowBox[{"Pi", "/", "2"}]}]}]}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Evaluate", "[", "Vmag", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"PlotStyle", "->", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"RGBColor", "[", 
        RowBox[{"0", ",", "0", ",", "0"}], "]"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"RGBColor", "[", 
        RowBox[{"1", ",", "0", ",", "0"}], "]"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"RGBColor", "[", 
        RowBox[{"0", ",", "1", ",", "0"}], "]"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"RGBColor", "[", 
        RowBox[{"0", ",", "0", ",", "1"}], "]"}], "}"}]}], "}"}]}], ",", 
   RowBox[{"PlotRange", "->", 
    RowBox[{"{", 
     RowBox[{"All", ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "100"}], "}"}]}], "}"}]}]}], "]"}]], "Input"],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {RGBColor[0, 0, 0], LineBox[CompressedData["
1:eJwVl3k41N8Xx21FSFnKWsa+RMRMJcs5abGlL5WlhSJJWZKlrClFCJUibbaK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     "]]}, 
   {RGBColor[1, 0, 0], LineBox[CompressedData["
1:eJw1Vnk01QkblkxSBkUxusoS41puF9eWy/vayZKdmqKQkCTdlFQyWVrElJQR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     "]], LineBox[CompressedData["
1:eJw9Vmk0lQsXRmaZpQxJxgp1io5r3BuZwzGUmUIoyVWUSreTS2kQZagMIUNK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     "]], 
    LineBox[CompressedData["
1:eJw1l3k01VsbxzWRoboOtxQyHITQQebhecxjxkIlGVOnhFDKmHIrRSh0ZShJ
KVyhDIXbIXSjS4PcbtQ15Pc75/fLXIpu73nftd691l57PX/svT/P9/usvZ6t
EBjuEbJUQECgnT//u9K5woydKgQI/G/sxH+D1un18ePSmYxeDuGDwW29c65q
BFyQEM64HumDrBSrY9u0CBArifzx6KI35v6zaNDNIiA1WfB7upI3LuKDeUdd
AvK++FbPPvLCrh+qJ+wNCXBL2r/Q+2UHau0dNu40JiBq7GT67K878HLL1QUb
MwK+HtXzEYYd6J+wOsHKkoDhjnnthKzt+OXbTJK5MwHS/Qcjjbd7ou+uSmx2
IYCTuP7iKRFP5DTuW2LqTsBKQbblW44HZsT+lWLkRYAupTyxy8gDVT63pG71
5/O2F2ZkmrjjhR2xtrWBBAjZfPRTEnDH6TptIZ0QAhQ3N+zU63DDlqjSs1vY
BAx0d37I9XJDr6lz59WjCRCu2rmPu8oVH7lZOZcfJSBbyndeosIFFasXxVSP
ExCpN/L3MWcX/HQ4PEM5kYAWLfbukkvbMJXaniV/ln+fg6N0vpEzcp1WexSn
EVAeGH3y1rgTut3tZGxMJ+BDeu51dp4TyrCNL0tnE9B/YGj7uwVHrBuXy1tb
QEBslsNXxhsH3GD3l3dOEZ9vzDgkPMsBk8uypSSvE9CwLWMVc5sDOoesyBcv
IyCE9afcgS57HB3mFohVE/B2sSsxqscOJYbulyxtJ8C1NAsKRGwxQywhob6D
r+/ghk7lFzYoYmLtc+gp3+++Xo+6fBtceuXFqv7n/P2Kp4vatWxw2n0itvwv
Apo0jsYtBljj4eQHnn7vCOhTT3jwmWWN3KoELYn3BPSUVmq2C1jjP6Jio/Gj
BIzeCG9vK7HC3ieqrm4TBLR6fa15NmGJzrMTaiumCZAPYBa8arfELsX65U2z
BATVO79Ny7fE1iSbJuY3AvZJ71KYsLPEKqNA5S/LSYjx3mClcccCL1ReXSjc
QEI2U2JJ0jnEle8C+z1kSRhYa+JdE4p4WkT9npA8Cb8cjTvrZ4sYF9qwL1KZ
hG9l7EPrViCyFV73WbNIkDL+pJq1BtA+Z/Vtng0JpoKSkRfQDNvbXqdcsyfh
ZcSowJywGeJ0wZ4dTiT8YWhyU+yVKRq4bpZodSNhqqN7uSnbFFWE7ROzd5OQ
dvvuGasiE1yRcHK7USQJf0p5XotRNMa6KepraxQJflSz1IF5Iwze51Nse5SE
MofqnOfPjbDddQvXM46E0+k/XIl4IzytOJh0OJUEy4yuDuUhQ1zeZXj3xq8k
ZDL8yD21BlhnWuqmXkACFSl5sPyiAQbfW/O5uoiEPQvf7m87ZIDt+R+x5QYJ
la7OwVdVDPBU2OX+gUoSzIeG6jYV6+NSicklqzkkSCqP6SwW6WHNmd23LreT
YNSf9sUyWQ8DFzucpTtJyLg7oNAboIecscI81W4SlK6eb2tU1sOUBidNq34S
amR1Pv9WvRWX+N3yieWSUF2j6Rv0QhcFyv1+G2ZwobD+unk86GAH9eZw8c9c
CN/mKCWgooMXWO5avlJcWFUirtwkpoPrGqwqX8ty4biE1peet9qo1al6t0uV
y6+fkqUBx7XRd2y6rMqcC1MtefolrSxsVDhTdILNBZMjjINL/tLCxBABP4Mw
LvgfKduufU8LrcuPy86Gc8HNnLQrP6eFvaxDBWExXKi8TfeFmWghAe75/slc
8Pyl7oV2iSau9ZPOtc3lwlbNAvvpOA08kv9bOoPDhflleR22u9WxfjH/DKed
C3C++dxlE3Vc9Pvl5JFOLvhh9Ji4jDqeYe6JedHNBW//OatfB9WwoEJkT/Yb
LpyKUBXsDlTDJy0hGgyaC5t3Zc24x6ii1Ij0M3EpHuRMmtffqVfB5s1nV4of
5oGKhirjylUm6r9a15MdwYP2Kh2VuVQmVsffypKM4kFsV/VCSAQTS3o6NkjF
8mCaK/v9pA0Tz4av0JRL4cGGLfp0waQietSmuGvm8sB5mGGp4aiI48YJ+Q4t
PJjoS03SElZA/xGxvc9+58EfwvuKc+fk8e35Aua2Nh5kLTBvig7LY/e7hxVu
XTyo29mZI/1QHmsSv7V4v+BBOUcnvidMHuM5x0ZCPvJgV49ISv4dOZxjC90e
J3hwf+nznwZOy+FhibxDB3g8WGb5RV5trxwGBD+YOzTJg/6gDoPlknJoKzgn
FP2NB6r9UQGXEjeiuOMRjZTVFAjfm7zT4iWL1x6vETUWp2Dpqp4eWksWWUaV
5JQEBbGzH09pCMmiiypRFrCeAuLsi9v99TI4WJyaul6GgsbSvWstMmXw0Dpm
cN9GCv6QuiTZuF8GFzJ+tzynQMFI/UcFcwsZTBP0U7BQouCiyqFHf66XwfWJ
Cz/mVSjoOfokIGxaGm/PXRmqVqMgqGwurpYnjYZh+s37NSgg/e+nX/SVwc7R
l1flt1AQIpSaN94jg16+kScGtCkolS3WbwZZ/Phy9c7MrRTctRUUZ9TI4vI2
h7UCxhTkKEiY4ZWNeMl4fLbelJ9vQttKWTE5VKw5/TIcKPhXzWt5crIc4vXW
zPfWFKiufDIXriePCUl6oq2uFBhXBT3YyFTAzyYKAokhFAT/K7qrRIyJqbUt
Q3r7KdCUbS8ydWKi5GbfZppNwWJVxP7NaUzU3ZB3Yk8EBVqyYv2iwkoYMS82
ZxpHwTrvqoV/RZSRrJsnFzIp2CpL5C1T2ITvNHtfHn9EQb73moyEks1YzBNP
WNZKwacdpdEj5GYMLPdUSX9MARUV3fKHtgaSSm9ir3XwedT7jmxq08DP0kOy
nb0UdGSfZgZRmiguQoVKjlGwYKr8pEmTha86NcWLxvl8B1uUmF4svJIa3rSJ
S0F06uO50UQWblwyI2YyQcFAMXskvo+FGvNf7wV8pYBjv9vPKE4bbT8KLVat
ooE9KZ36Y1gHhUsdbhr+RENYo3eTJEMXuwPOu3AYNCzQt+wrLHTRc3D19dfr
aNDcqiITUaKL/q9+tl1UoGHfTGzDPfZWjOMwMx30aci8+2n+zXp9NE8OMXpp
SEPTonjaogf/vTS/NexrQkPhuTWz1AV9PNuorheBNJhVO25xWmaAudXab3Md
aWg7uNal7ZsBVheB0qgfDX+PF1xcKWOMMydmhAICaHh45fB3w2Bj1Pe+xRsM
oiFG+/JPjyqN8eGaNbVv9tPwtPCdzoS1CXYkD1k8O0LD71tv6d5ONcWVe7KV
7WNoMNRqOrDyrSk6GdkKPzlGg8J5kVATlhn2TlX2tsTT/H7s4PGwYTP8OzBh
b80vNNRGvM656g+4EbSttpyjgS46u0upA9Bfekyl4jwNclactarrkF+vzp9u
ZtLQe2N058VTiKrVAi8UL9Fw8GP0MaFHiAcv1N0vzuHrlzUwvvEz4qS1TMKv
+TS4jn1YcT7cAnUVev3XFvL1ww8g+ZsFHv1+yvpSMQ3fQxc8yiYtcOE+TzS9
lH+e/5F7+09YouCmh/nJVTTU1FaN11VYocOy8MTv1Xy+Zqvfn/D7hwvvFQNP
1NIQoMEyt/exRvEraWrRDTT0mP6p18Swwe3R5qummvj+PdUbczhqg7lu05Nh
zTRMit6RzxiyQRnhXQ2hHD6vN0uC12KLe8dWFYy205DtfaNimaEdljx+nBTQ
SYNKaW3X63o7HC2MCRp6yvfHyekMA+xx0wk1u93dNLzUFL2f+twe2V6D6gPP
aZi3S9ORDnXACp2s1Tv6aBBcz+aMCTuiDm/+tUs/DeHUyYU9UU4Y01nR+GyA
hvYPnU9dzJyx4YZ/of3fNORbfsmXkdqG35IkTz4ZpGH2ffX4XkEXNPPtCrb8
QMMPR1OGo6grJhvG27cO0+DzKnGS/bMbciRZGqZjNDyQ6ZcSvO+GK6ZG1jSO
83kzxAdqQ93RvidvRo9LQ46yeE+dtgemlTu9qaFo2FQpENUq5Yk9qT+atkzQ
EKSjGlivtB1/CqwtqpiiQeLazZH3/jvQwzw0RW2WBoZL9IOvg16Ys0F6X9ln
GhrsHBWtH/ggZ8S7doYf//+/8B/0v8oq
     "]]}, 
   {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwBoQNe/CFib1JlAgAAADkAAAACAAAAlgs+gYhp1T9vR8+GTb8pQFQl4QXI
a9U/+DcCEIOxK0CGXr3zxnDVPz2zW3x/iC1AuJeZ4cV11T9RXqvdidMuQOrQ
dc/EetU/Cb20Fk/nL0AcClK9w3/VP28NHMnDbTBATUMuq8KE1T8ILCP8c90w
QH58CpnBidU/eL22Qq1FMUCwteaGwI7VP893fhZGqDFAFCifYr6Y1T/wQ8kW
K2EyQNwMEBq6rNU/8JmwL8GzM0Bs1vGIsdTVP8FI/0aQHjZAjGm1ZqAk1j8H
vJmDCs86QOpArYgLKtY/va/HFswiO0BHGKWqdi/WP27G5QQddztAAseU7kw6
1j9sPg1olSE8QHkkdHb5T9Y/nKhu4/N+PUBm3zKGUnvWP397lyzwMUBAxLYq
qL2A1j+bhvDQmGJAQCKOIsoohtY/ZjDUI9iTQEDdPBIO/5DWP13VTx4w+EBA
VJrxlaum1j/WZxWC4MhBQEFVsKUE0tY/ajhWfJCPQ0CeLKjHb9fWP8L35Ipo
zENA/AOg6drc1j/oGIlVPQpEQLiyjy2x59Y/Wyl9tf2IREAuEG+1Xf3WP6VP
7N7Nk0VAjOdm18gC1z+YfJReftlFQOq+XvkzCNc/1xHkwXQgRkClbU49ChPX
P3KMgYFeskZAHMstxbYo1z+VAcCfbedHQHqiJechLtc/9rZLapI4SEDXeR0J
jTPXPxvs8+Nfi0hAkigNTWM+1z8YK8ecMDZJQAmG7NQPVNc/dChkTnGiSkBm
XeT2elnXPw7F59SfAktAxDTcGOZe1z/eFK9zAWVLQIDjy1y8adc/OUYRbLMw
TED2QKvkaH/XP+WpQXBl5k1AvKTrm3eE1z/2NTY74lJOQIIILFOGidc/+uIe
T/fBTkAO0KzBo5PXP9rXbi1RqE9AJl+unt6n1z+NV6AccMxQQOzC7lXtrNc/
y8rEEpoOUUCyJi8N/LHXPzlemTiKUlFAPu6vexm81z8NCAvZCuBRQFZ9sVhU
0Nc/mO2Lyu4TU0Ac4fEPY9XXPxDHklelZlNA4kQyx3Ha1z/lvpuH3rtTQG4M
szWP5Nc/+5joXlRuVEA0cPPsnenXP9GhecrTy1RA+tMzpKzu1z+4ML21WyxV
QIabtBLK+Nc/x2DPQyT3VUBM//TJ2P3XP1KApGO7YVZAEmM1gecC2D+jWUh5
CNBWQJ4qtu8EDdg/h0p1S5W4V0BCW6vxxBnYPwAAAAAAAFlAyjC6lA==
     "]], 
    LineBox[CompressedData["
1:eJw9mXk0lG/Yx21Zy65ky9h+dmImW1yXLSQ7UZZEskRFtpKUlJQkIUSivRQV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     "]], LineBox[CompressedData["
1:eJwBkQNu/CFib1JlAgAAADgAAAACAAAAbBd99kiw7D8AAAAAAABZQJ9PWlma
sew/hVp9ppu6WEDcLdDTebzsP/ZiuIQNu1ZAn+sRfQO/7D8d0apf4E1WQGKp
UyaNwew/kt4PeCnkVUDpJNd4oMbsP44m+VdyGlVA9hveHcfQ7D+ao7Q3vKlT
QLrZH8dQ0+w/wkxeGghUU0B9l2Fw2tXsP2TgQimwAFNABBPlwu3a7D/Wrvia
rGBSQBEK7GcU5ew/QHXuC8w4UUDUxy0RnufsP10z38Ri81BAmIVvuifq7D8G
isoLp69QQB4B8ww77+w/o5A4efUsUEAs+PmxYfnsPxRCk0QHck5A77U7W+v7
7D/t3zrSs/5NQLJzfQR1/uw/39g6lNeNTUA57wBXiAPtP8dhKAsrs0xARuYH
/K4N7T84nkVRxRdLQAmkSaU4EO0/DZT6Aue1SkDMYYtOwhLtP/S0SJ7kVUpA
U90OodUX7T+lByQCNZtJQGDUFUb8Ie0/qSgmn5c5SEB7wiOQSTbtP252b2aK
ukVAPoBlOdM47T8MhAsLPHBFQAI+p+JcO+0//yr4lAsnRUCIuSo1cEDtP9O4
xq/il0RAlrAx2pZK7T+VBIbLlIVDQLCePyTkXu0/op9RPe2KQUDzevMHYWHt
Pyfck3A5UEFANlen691j7T9FF33bMBZBQLsPD7PXaO0/pQmcxg2kQEDGgN5B
y3LtP+9ZF3b6jT9A22J9X7KG7T84FhS11Es8QAYnu5qAru0/DOehvTNZNkBJ
A29+/bDtP3MuKlRf/jVAjN8iYnqz7T8sWZiK3KM1QBGYiil0uO0/EZUtyKbv
NEAcCVq4Z8LtPzU8ASZfiTNAMuv41U7W7T+fwzDXNLowQHXHrLnL2O0/4mA3
+8NeMEC4o2CdSNvtPwWPDCCsAjBAPVzIZELg7T/qkJTYApAuQIA4fEi/4u0/
MX7atjzSLUDCFDAsPOXtPxUBGTjiES1ASM2X8zXq7T/G2fb3c4crQIqpS9ey
7O0/KHL0ehq8KkDNhf+6L+/tPw9TT16M6ylAUj5ngin07T/VcQ5R6DUoQJUa
G2am9u0/aZrIbD1NJ0DY9s5JI/ntP2RRsyymVyZAGtOCLaD77T9xn0GggFAl
QF2vNhEd/u0/kf07ye4vJEC2WvgO0ADuP+wyUFaTxyJADga6DIMD7j8PYixa
N/QgQDMxW75mBe4/14LXK7ygHEBWJKhO
     "]]}, 
   {RGBColor[0, 0, 1], LineBox[CompressedData["
1:eJw9mmk4lA+0wJEWu2iV/Gds2c0YSpFzRJZS1lKKUEkLIkpKpLKWyJJEJJRQ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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0.34, 0},
  PlotRange->{All, {0, 100}},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.5184567421232*^9, 3.536265339383233*^9}],

Cell[BoxData[
 StyleBox[
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"Evaluate", "[", "Vmag", "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "1"}], "}"}], ",", 
    RowBox[{"PlotStyle", "->", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"RGBColor", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], ",", 
        RowBox[{"RGBColor", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0", ",", "0"}], "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"RGBColor", 
           RowBox[{"{", 
            RowBox[{"0", ",", "1", ",", "0"}], "}"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"RGBColor", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], "}"}]}], 
         "]"}]}]}]}]}]}]}],
  ShowStringCharacters->True]], "Message",
 GeneratedCell->False,
 CellAutoOverwrite->False]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Evaluate", "[", "Xmag", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"PlotStyle", "->", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"RGBColor", "[", 
        RowBox[{"0", ",", "0", ",", "0"}], "]"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"RGBColor", "[", 
        RowBox[{"1", ",", "0", ",", "0"}], "]"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"RGBColor", "[", 
        RowBox[{"0", ",", "1", ",", "0"}], "]"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"RGBColor", "[", 
        RowBox[{"0", ",", "0", ",", "1"}], "]"}], "}"}]}], "}"}]}], ",", 
   RowBox[{"PlotRange", "->", 
    RowBox[{"{", 
     RowBox[{"All", ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1000"}], "}"}]}], "}"}]}]}], "]"}]], "Input"],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {RGBColor[0, 0, 0], LineBox[CompressedData["
1:eJwVV3k4lG8XFvkRRZaUpbIlpJU2lXNKZLJkX8cSEsKMQcmSJVubREkRJVJo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     "]]}, 
   {RGBColor[1, 0, 0], LineBox[CompressedData["
1:eJw9lnk41QkXx69lsqRUlBRTRBEjSduIc1LCm+ReW5K41y4T7iX7y0X2Zcok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     "]], LineBox[CompressedData["
1:eJw9lns0ldkbx0+RXHIrmtCYQlOkGtKUDM/jUu6UlJSQKEoX7zkccj3kuFMh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     "]], LineBox[CompressedData["
1:eJw9lXs0lHsXxyWXQkkqulAuR7dRnCK3t71DLnUilaTwJpQQYmYYzTCGGYZI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     "]]}, 
   {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwB0QEu/iFib1JlAgAAABwAAAACAAAAlgs+gYhp1T9y7CS+XThhQFQl4QXI
a9U/cZUvbYWdY0CGXr3zxnDVP6aok28TLmZATUMuq8KE1T+tua3b8DptQH58
CpnBidU/2NUyGUjObkCwteaGwI7VP+iDStlVLnBAFCifYr6Y1T+XVPNqirpx
QNwMEBq6rNU/iXZLVgXgdEAORuwHubHVPzAOK2sir3VAQH/I9be21T/tDM3m
ToF2QKTxgNG1wNU/wrvXehQweEBs1vGIsdTVP2peZIoTv3tAng/OdrDZ1T/v
twW9oa58QNBIqmSv3tU/vEyQLmijfUA0u2JArejVP0m8ccianX9A/J/T96j8
1T/dOHbq0e2BQC7Zr+WnAdY/wXGmCwF+gkBgEozTpgbWP1WDPerUEYNAxIRE
r6QQ1j8Humdm/USEQIxptWagJNY/WOfnZpPdhkDqQK2ICyrWP2zfY0ljnodA
RxilqnYv1j/Orn0iAGWIQALHlO5MOtY/5ECwIZYEikBgnowQuD/WP572x2sQ
3opAvnWEMiNF1j/OuPBFWr6LQHkkdHb5T9Y/hFUUyH6UjUDW+2uYZFXWP9Pv
YaHyio5Akkgrjj9Z1j8AAAAAAECPQNpM34I=
     "]], LineBox[CompressedData["
1:eJw9WHk41N/3V7SQZE20yFb4FCJFyjn2hMjOvEOSbMkaKqQQKpUskZKlRRFK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     "]], LineBox[CompressedData["
1:eJwBoQFe/iFib1JlAgAAABkAAAACAAAAmvEsNDWg7T8AAAAAAECPQPu16wuN
pO0/LZ9aEuv6jUAGJ7uagK7tP85UCWLYS4tASQNvfv2w7T8fkF1zHquKQIzf
ImJ6s+0/xnYBmX0OikARmIopdLjtP1OSqivu4IhAHAlauGfC7T9d6b/apbCG
QF/lDZzkxO0/BH4VkrgshkCiwcF/YcftP763bqDLq4VAJ3opR1vM7T/j+JnR
c7KEQDLr+NVO1u0/BdTHr1/egkB1x6y5y9jtP1DitSUDb4JAuKNgnUjb7T9c
qKDgqAGCQD1cyGRC4O0/3zy/dm8sgUBIzZfzNertP4i9OmwOJ39AiqlL17Ls
7T+GbcfyrF9+QM2F/7ov7+0/rnYO4E+ZfUBSPmeCKfTtP6XbdmimDHxAlRob
Zqb27T/wFgq5Q0R7QNj2zkkj+e0/p/gMjWt4ekAa04ItoPvtP7SxD56KpnlA
Xa82ER3+7T+77zOUScp4QLZa+A7QAO4/hjeOkWLFd0AOBroMgwPuP/oXQ7Sr
iXZAMzFbvmYF7j/E2fR5qux0QHEMy3Q=
     "]]}, 
   {RGBColor[0, 0, 1], LineBox[CompressedData["
1:eJw9mXk0Ve/3x5GSOVMiModSFCLK3qYbSsk8T0Uq85ApGRLNIWmgiE8pNChU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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0.34, 0},
  PlotRange->{All, {0, 1000}},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.5184567504536*^9, 3.536265340391597*^9}]
}, Open  ]],

Cell["\<\
Here is \[Alpha] plotted also for comparison.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Evaluate", "[", 
    RowBox[{
     RowBox[{"\[Alpha]", "[", "t", "]"}], "/.", "solalpha"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"PlotStyle", "->", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"RGBColor", "[", 
        RowBox[{"0", ",", "0", ",", "0"}], "]"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"RGBColor", "[", 
        RowBox[{"1", ",", "0", ",", "0"}], "]"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"RGBColor", "[", 
        RowBox[{"0", ",", "1", ",", "0"}], "]"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"RGBColor", "[", 
        RowBox[{"0", ",", "0", ",", "1"}], "]"}], "}"}]}], "}"}]}]}], 
  "]"}]], "Input"],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {RGBColor[0, 0, 0], LineBox[CompressedData["
1:eJwVl3k4VO0bx5nFzCBLaSEqWaJIb0mo3KVekSWR7ESSJFkrWyRJ1t6UCkWL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     "]]}, 
   {RGBColor[1, 0, 0], LineBox[CompressedData["
1:eJwVl3k4VO0bx5nFzCBLaSEqWaJIb0louZ/UK7Ikkp1IkiRrZYskydqbUqFo
UUiWikT2QosoDUaWxpwZNDNaROEMv/P761yf61znPPfy/T7Pc6t6nbQ9QhIT
E/MQFxP7/zNTase5xGNMiGGoTUZ2iKEDGmxq23Em7JRMxl01xFGCe+1ESyAT
RthSVhUh4qjq+k326zAm6Jv5LftbII6+dYZ1vIpgQpHhzG21z+JIWdK2tjmG
Cc2Uwwonp8WR1a71j5rimbDSJ/xPkxIJnY2SvNl4iQnrZw526hqRUFkFL6Eh
jQl08m6aoz0JKWjletXdYMKG6hFWWiIJmXpG2tTeYkJSXXLWmjwSOpPlsOPl
XSa8WpzRUlRJQv3SckrVxUw45iZV8fcrCcmYCmgvypmQsDew9s9vEkIxbZPP
K5nA8mZ3WNLJ6P7P2I8VDUz4drNhtaEuGfl3/0ws/8wExqGvZ1yCyOi27IdT
ZSwmjP4rvsr3HBl1mhV5lw4y4Z6PWr7Kf2SkX+OFHo8yYWjFwwU3S8kIz+36
U4AzIbTa+ZfVGBmlHKvwyVPvBmbfgmfRthT0DT1OlFrbDQf8SzfwPChoz7L8
olN63UBtfFGueoKCSK1Xxy2Nu2FpKlNF8SIFhauHnpre1w3TszGtBi8oyGdo
Y4JtZDcoGt19Y7WUinbal+VTPnVDS1pQKb2Rim7rFLSe7OkGhwOOn+beUhFO
zhvr6+8G+w8a27DPVFT1JF23fKQb8OFdh8+OUtF6uZMVbqJuoExVvJyWkUDK
73RfV2r1wPXiHRr7nSTQFHqE+cb0QOz6sjx9rgR6eZ+ffTq+ByhJu/oWCCVQ
HF3HLuFSD2jIHlUe+i2BZDqLG+9l9ECissIGPwoNaXqU3B582AOfuJ4PNdRo
6GB0ueOBzh6QuLXbz8yDhipePH8Pqr1g9PKpdc8nGopQ+XveWrMXnt/bJvuV
RUPonOFWt3W9kL7kRCLnKw29N3tRGLG5F9hmS9l94zSE9VQnVJj3QoFsaVOK
JB0pTNWidcG9IGPeoMvYSUehG189W9LcC81oY0RVER356K/K+6+tF6xsDnrX
lNORo0FUsvSHXqj3JDFfVNHRVmN9LxKrF1RuvzhV2EJHJJP7suPjvfDfzNy3
A8N09HuX2Kzv717YuX2x8eYxOuL+68rjTPeCdE2pt/wPOmozV6hlUVjQ9LQt
pFZER9UWgQUHJFmgk3j5eCqFgYqt3md0yLKgkB94xEmKgW7v04rZu5gFaUOl
fqoLGSh9f7zfayUWJI0FxHOXMVCs3Vd7tIoFeZ8f1eSvZKBg+207azRYoPHd
NP2qCgN5O9zQMVjHgtdb80j9SxjooNPvpeUbCE7fv2ONHAOZudiQdQxYoMbg
Gp1iMJCRW/H4g60s2KRAFbaRGEjZ0/t1jikLrK02OoVP0pHM4YaypZYsiNy6
gdQzTkdiR5RzruxngbhUtonhKB1xfD8HJ7qy4KXckB/1Cx0VBe5eFRrMgs2z
nhffNNBRTnCe1PfTLGB3bFHcVU1HqaH41LFoFmDnrtMantJR4Jln7R6JRP6p
YYPND+hoS6x6pMVtFmSfPf/iVwodvUqndK9+ywLnn0OZI050NFTyKvmjah8E
VGZWUadoqFNIEWxc0wfOxmVvZ7/TUIPOv5ZXdfrA4122/+8xGsorei3tsKUP
ai9g1sIBGvJ60JLab9kHFqbzy0SvaYh3qy195HQfmAVX7f0vk4aEKe8zRO19
EGJqWxNsREOzfp+ztSO+gGNOclTABQm0bidtzqemH0qbuw97mVHRnruqR8uX
DsLzUd1fHBoFnVbxWM12HQI/aZeUFT9ISEdgL9Vj9RVa5L58Y30XR4tkf9Bf
zXyF1IUTN6u+iyFKfXapWg4bnhzoWPZ6mRjq27bbbOg2G4IlOrgui8VQabXg
a9YdNiTSytp/y4sh58rtCxc+ZIP68hNTOlJiqPzxUKjYEzZstq1tPzE7D+45
asYDrWy4s/W5hU/LPFSFP3qVOcEGGQfNzBce85D2x87NdooN0Q//CTjlNA+H
w/DJBdNsuO7eJW1oNw8yQVZrLsyxYUluZPkb03k44vv9UghjGIJ+U9TWrJ+H
hQ6b9tmsHIa/entkOkRzcFy/hsWwGIYbLkcd/uTNQUMns7jKahjWdGisDcqe
g8UnfsQctRmGnlAzwx/X5qA+X0Pztf0w7BuvWD6XNAeLll4Ojj00DHPKv644
hc1BzbS31J+wYZDPCxYuspgDqXqZ7VjeMJh+N3d+OSOCQy7achn3hkFWyYc2
OimCij+7ODsfDIP+ItPbij9F4LEh/FLuo2EYsenITRsRwdM7HKZzJfH9+Of0
hs8icImvCvj4bhjcG5KXmJeJ4JG5V17d1DDE7jOJVPAXgb6O6g6YHobir8dY
Vr4iqJP5+qV+dhhut3OnU7xF0NnltrRRjAMl9zWuKruJ4LebU1qzJAdeYTGP
z1mLYEewTVTbCg7UVxUdP7pRBK0HZJXMVTngRvKQm18vApstH56/UeNAZmJ9
fc46EXjhFhNvtTigrmxu801dBBcT9vi1b+TAJn29Zx+WEutl7XD8ZMoBVcNG
p4Y5HJyiRZO25hwYUHV7Xj2Lw7DHy4wuCw6cW6x5pOYvDr/VjTs+23Bg56ZF
TR2/cFAs3Wza48yB3jCVqd0jOHg16+j3B3DgH0v7fu+POPDz+R9dgzjAGt++
ruUDDqGJRScHQjgwtcRKav17HC5aaT0aPMMB3ne7NPlWHIp71Faz4zigyX0j
qVWLwyRfSY6XyYHJOjGVzCIcrt4aac25yQG+7a8fGwtw2LTvWYxdDgcMJh2a
e/JxCHpi9b3hDgfSKoZCje7gIDwT+yG7mAPMfvE4txs4pKy1SrAt5cCzcPFG
40wc1vUr7mA84UC6AW3Vqqs4HIOnj08958AjMsOafBkHLpWXsr+JAw4lzt3r
EnGIf/5kN/01B/a22cftTcBB7VgMXtdKxHe40z8oHgfP98v8ddo54PwlXqo3
FoeBKxYWtF4ODIkVdNIjcIjavYxc18cBizPVH4+dwWH5FFYdOsAByXRPna5T
RP2dzq4dHubADcbITF0IDsyV5YxaIQdsFw/azJ4g6vcxujHkBwcYxpIhuf44
LDq/N3ztBAd+BBtIWB7HYT+PM3r9LwdOv1yVVOeLw4/rZXnWswRrisXGH8Uh
3TzakTrHgc2rVv+09cGhvXhJWzAZg9T0BmuGNw7+7pwYbQkM6vkD8NMLBym5
si1f6RhcCY6pYHviYB5i/tBKBoPV5/sN+j1weG0UlaCliAE2bvR2iysO3nyz
HUPLMRBGay7zdsGBfGvx1LUVGJRZzk/fcMZhp1jpEbI6Bu+qR2KUnXD4Wh6p
Uq2JQbQLdc1xRxxiDpsxA7UxuKq8zrfJAYfaFvbuwfUYfN4jqE06iIPrmRL8
6j8Y3CuRZM7a4zCrHfnMQh8DyUVbksMIzvqyx5+0BQMZmYvsPwdwMEpVUH9h
hMGajLneOIJ7d7C/nNyGQSWWHryE4NM/HmdoAgZhl5aXPrHDYcndCIuBnRic
NwlMdyC4wm4P+epuDExJFgpUghMtqi4o78HAu7J/uN6WiGeXNj3fHANbTpRx
HMF6W7OSdC0xKFTIXm5JMGmT1IJKawx2bL2ZoEIwc21U+o79GLgVvouc2o9D
wWqhfKsdBimy4bPdBEcquV/ddxCD9vA+aj3B1gs7lvQ6YuBjtTy7hGBVSXTz
kAsG/+5xqskn+Ld4+fIxNwzeRtz3uU9w27Tq7aBDGGjtn88pIjj755VVM14Y
uF5yd68iOGCMfC/uCAZphoVF7QSbsEM1pHyJ+r2rOveN4MUs7sMMPwxeUZ04
MkS8o50H1yqfIPKjm3UYE1zT1lp8/yQG8fsM/g0gOK3BUE83GIPDVS27Cwn2
rCosrwgl+nU+rZ1PsH6Zkv6O00S9nRcPbSbqRytIrmwJx+CcLfPMRYL7cnHD
fVFEfr+Ms74SfC59cPuhcxgU3T0SVEj058DFfQ2j5zH4qNegoUj0VyumwSQo
AYPr/nz3ywR/CLi7Jy4ZgxcLLFyvEfq447PorWQaocfkwhVqhH5C3eMtMy5j
APM6XlUEK1n77L9/jVjvmrfvNKE34b89XTo3MDiY1quVT+ixYbvZwYosDJ7t
+HnEkdCrj+5al5ZcDMqH522YhJ6NNLIHrO9icLzVEr9N6F1aRfpQz30MYj0E
KwLdcHgqPe49WojBmMauV1qEPxIoHiOBxRgY42O75A7h4Ix3HJsuwcBxokl/
nmAxQXmA5DMMlAvdD08QfrN8F3ZGpw6DX6zXTfqEX1c282aeNWDw+/5QlgPh
51/VDtHbmzGQ+pbKPHcMh5tFRnHWbRi8iT7pJyD8z7skSg78hEFctXK3YhDh
J7MLuc94RD4p+x93ReHwyd3XdcMY0e8M+QuHz+KgHmahWMwn/LmXsX8mBoe3
d+Qz7v3AYMmGjTXbzuOgMHsr4coMBvpoT6pCEqHXx5UnAmW44NFuWbbgJg4z
zTfXCuS4kHV17KxUNg5WfVEjRxdx4VVt0yK5W0S8Ers8PZZxwcgm5LwusR9v
O9RxwHo1Fyr3z698UYhD58LRrToGXDDNtXOTe4nDau13fx8aciF2bZV4eB0O
YVBSobaVC2Xm45tHG4j++YfqLUdcOCy5GfpeE/vNazE1yb1c+BAcf0K6E4e/
pxUlR924oCQROJLPJfwysLf33gUuJMPrW/8tFkFS09ZS+0QuaHRRn0sqiuDX
Q50EWjIXQCNnIklZBE3BMvrHL3Phkw2/IU9NBN70T+kbs7nwRo26UJU4bws2
Oe1pLOOCf1F92UkbEaxPOlo5+IUL6x9R7VWuiCDzpGPq5UEuDFRaz5/MFMH8
AXNvEzYXvBmyy95kEeftynULH/C4YMznR6fdE0FQxfiJEz+J/PZ+CD9SIYJn
X8M0cAke1Dr2aEGfCIy3xF9V3MgDne3r94ZrzUG3l6LBLX0emMk3WG7RnYOQ
tJKeVVt48NJ3ynzmnzko5vYqaW3jATt6/er0rXOw4qruHQNTHtjOOL+bsJ4D
0s/ux3bOPMj5Q1qcf2oO3hVpt6bG8SCg07Ey8c0cuK7omBbv4oE320nXN4q4
rykGV9QwefDm/XWVxrh5aFy0OCislwe03CslKy7NgybDZXR0gAfnN+G5I9fm
4fsEr7tjlAfJ7LQdZaXzEPdm7umtOR5I6ZmdWIbNQ0Ho+gCjtSPQXBIpXKgl
hibfpg4HnhuBSGMTP+0sMXSD4h5qqz4Kdy2o/tvjiPvsYMVd0qtRUPUI2J8U
QULU6HMHjILGQCZxYn1mDhmJFbqXDi/8BvSQ7e821VFQcFZp6sKmb6B7JFPe
lJgva9cl0uUD+LDxJPX+wRAaMvi8tP1KIB9KfOul287QUFnUw/8UQvjw5FiK
/9azNHS3vUVp2Rk+rAw9pKx1iYYST1J1V8bxQW9jabJiLg3ZPo3br5vJhzXX
G4w83tHQiHF0lnkdH+6rSuulaNDRIY60x7sGPrRWjwSarKOjvuQcNatmPuyq
5i2c3UBH7/trim3a+LDaSetiyDY6enJ2ps7hEx/2tbvdPWdHR1FNpzlHeHxI
eavusiSOjib9aAUjo3zosNe79vsiHQUsuu5/jM+HgitlocxUOvL0rpz0/8EH
31G3Lbk36chUYpIWOkPEe/2tvR0xb8rvDdaJkxGARPhkrAmbjvIaZaWM5QVQ
bNxE6hyhow1Gj8d+LhLAZldrqicxf1lrjT7wVBSAVcGvotRZOhrIvXBBUVkA
RWvC3bSJ+c1/qZr3xxUCMP6QU9pGZ6DZtAaTS6oCGH/sXnhcloGSJNxVd6oL
wPzUoO1CYj5UPDs7/1dTAKdlXZ69VGaggskbg2XaAlivYv8peRUDGZ4wqPXV
EUCz1t0RliIDtWJd2av0BLCFGrpOfRExX7oGRfT+Q8QXT7/mJ81AvC4Zp8v6
AgiajFj+mMpAlGbzJWLGxHvlSmfNv3SUYTzy+/k2AbwPIIm7/aSj1U/iu06C
AD76bsxN/0ZH6E795aHdAvAzz88Z7aej6JjNUvX7BMDhTMT7NtLR1FZVsbNH
iP8fbmzNvERHF57WDW72FYBJoolsItEPhXWutUI/ATRsu5oXGklHm5SuR7gF
CiBWIyQAThDz5l/pyW2RArhH17HIsqGjsWd/x2YvC2DC8dug4xI66tft7Ap/
KQDJ2VSHS7doKJcvH02uF8AezYyyvcR86FVop5naKICafSnLJNJpaEy950xe
iwBeIam3frE0NLV8UKW1UwCW+pppY140JC8pOKrAFcDkdA2jSJOGTHk0vGSB
EC6wC0gXCyQQ4755vqGcEMRkJUtc8yTQe89k66aFQrjIrZTWviGB7AZk7jCX
CmHrqn7T/IsS6NDnxaa4qhDGxK9qrPGRQJFNapfNDYQQJLIz1FKVQGW3QR1z
F4KFSU1gYioVTURM0Dw9hRCQXbB47jwVGTg85A8cFoL2XXva4QgqqpGVfdrj
K4RMxs1N0z5U1BI7uPNdsBAe/VgZvBeo6ItXtMeTBCGoygXeWCCgoBXwzy69
S0I4/iAPtrMp6NByrmZxshCyz68xseumEP23HM+/TOT35qycXgMF/ditHH0z
SwgxshmQcoWCJNbUZMWWCOGxyh2lwQ0UZE4+eVZUJoQu18v3fqlRUMrQaq+I
p0JYUHzsU+8SCpK/kaQdWiUEyvIXFvI4GSkznKuONgnhTXEm5VszGXlwF+Rg
r4QwcTl4bFcFGd1tbIzxbCXyM9sy7fCAjNZEaO9xeS+ERP1SQc5FMtrI/8u0
7haC0Xv5KDFTMgprLX7xrlcI916SWjL0yajq3qFbZl+E0B538G3xajLa7trm
bfJVCORL+NudIhKKNYwyqx8WEucB5cOdMRJqUtigs40rBDW9u9nWTBIya78+
sfmbEFbUaIbpF5FQUqFFzxOBEPBBneBNGSTUfmG+Wu+7EAZC2J60SBKS83p6
u/inEDJkXHSiPEnIdsfROO3fQtiUpvbI0pSErikt93kwJYQjtKh8RW0S6p36
YK42LYQbOJ7mxCAhpa443bxZIYyHiNkb8sSRW6mBvMqcEAq04/6zrhNHlc5/
ZTrFxmFTMGmZZZI4kpGolj5PHge192/IMybiaNM/LnU+1HGgxCc/Rl1i6H8p
+Zbj
     "]]}, 
   {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwVl3c41f8bxkkhymrTnogiKpU8NIyMJElk74YRKkokZDSEUjJCZIaM7MeM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     "]]}, 
   {RGBColor[0, 0, 1], LineBox[CompressedData["
1:eJwVV3c81d8fJoUoq017IoqoVPLQMDKSJJG9G0aoKJGQ0RBKyQiRGTKyt/iq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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 1}, {-3.1408916885590292`, 3.1408916885590292`}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.5184567547436*^9, 3.536265340592781*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1350, 633},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
FrontEndVersion->"8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (February 23, \
2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 210, 7, 67, "Section",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[814, 33, 69, 0, 34, "Subsection"],
Cell[886, 35, 206, 5, 26, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[1117, 44, 166, 4, 27, "Input"],
Cell[1286, 50, 166, 2, 20, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1501, 58, 62, 0, 34, "Subsection"],
Cell[1566, 60, 484, 16, 30, "Text",
 Evaluatable->False],
Cell[2053, 78, 507, 14, 58, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2597, 97, 43, 0, 34, "Subsection"],
Cell[2643, 99, 218, 6, 26, "Text"],
Cell[2864, 107, 197392, 6343, 192, 194103, 6286, "GraphicsData", \
"PostScript", "Graphics"],
Cell[200259, 6452, 173, 8, 26, "Text"],
Cell[CellGroupData[{
Cell[200457, 6464, 530, 14, 27, "Input"],
Cell[200990, 6480, 683, 19, 31, "Output"]
}, Open  ]],
Cell[201688, 6502, 373, 12, 30, "Text"],
Cell[CellGroupData[{
Cell[202086, 6518, 146, 4, 27, "Input"],
Cell[202235, 6524, 1218, 35, 31, "Output"]
}, Open  ]],
Cell[203468, 6562, 50, 0, 26, "Text"],
Cell[CellGroupData[{
Cell[203543, 6566, 108, 3, 27, "Input"],
Cell[203654, 6571, 2704, 79, 34, "Output"]
}, Open  ]],
Cell[206373, 6653, 174, 3, 26, "Text"],
Cell[206550, 6658, 253, 7, 26, "Text"],
Cell[CellGroupData[{
Cell[206828, 6669, 886, 22, 27, "Input"],
Cell[207717, 6693, 990, 30, 31, "Output"]
}, Open  ]],
Cell[208722, 6726, 129, 3, 26, "Text"],
Cell[208854, 6731, 160, 3, 26, "Text"],
Cell[209017, 6736, 102, 2, 27, "Input"],
Cell[CellGroupData[{
Cell[209144, 6742, 115, 3, 27, "Input"],
Cell[209262, 6747, 1594, 46, 31, "Output"]
}, Open  ]],
Cell[210871, 6796, 136, 3, 26, "Text"],
Cell[CellGroupData[{
Cell[211032, 6803, 89, 2, 27, "Input"],
Cell[211124, 6807, 694, 20, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[211855, 6832, 84, 2, 27, "Input"],
Cell[211942, 6836, 694, 20, 27, "Output"]
}, Open  ]],
Cell[212651, 6859, 57, 0, 26, "Text"],
Cell[CellGroupData[{
Cell[212733, 6863, 399, 14, 27, "Input"],
Cell[213135, 6879, 2663, 73, 49, "Output"]
}, Open  ]],
Cell[215813, 6955, 147, 3, 26, "Text"],
Cell[CellGroupData[{
Cell[215985, 6962, 118, 3, 27, "Input"],
Cell[216106, 6967, 3102, 90, 56, "Output"]
}, Open  ]],
Cell[219223, 7060, 137, 3, 26, "Text"],
Cell[CellGroupData[{
Cell[219385, 7067, 89, 2, 27, "Input"],
Cell[219477, 7071, 1354, 40, 33, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[220868, 7116, 84, 2, 27, "Input"],
Cell[220955, 7120, 1403, 42, 33, "Output"]
}, Open  ]],
Cell[222373, 7165, 57, 0, 26, "Text"],
Cell[CellGroupData[{
Cell[222455, 7169, 447, 16, 27, "Input"],
Cell[222905, 7187, 5314, 136, 93, "Output"]
}, Open  ]],
Cell[228234, 7326, 133, 3, 26, "Text"],
Cell[CellGroupData[{
Cell[228392, 7333, 112, 3, 27, "Input"],
Cell[228507, 7338, 2961, 82, 49, "Output"]
}, Open  ]],
Cell[231483, 7423, 167, 3, 26, "Text"],
Cell[CellGroupData[{
Cell[231675, 7430, 179, 6, 27, "Input"],
Cell[231857, 7438, 14936, 364, 278, "Output"]
}, Open  ]],
Cell[246808, 7805, 230, 4, 26, "Text"],
Cell[247041, 7811, 71, 0, 26, "Text"],
Cell[CellGroupData[{
Cell[247137, 7815, 85, 2, 27, "Input"],
Cell[247225, 7819, 421, 12, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[247683, 7836, 80, 2, 27, "Input"],
Cell[247766, 7840, 417, 12, 27, "Output"]
}, Open  ]],
Cell[248198, 7855, 53, 0, 26, "Text"],
Cell[CellGroupData[{
Cell[248276, 7859, 258, 8, 27, "Input"],
Cell[248537, 7869, 809, 22, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[249383, 7896, 191, 6, 27, "Input"],
Cell[249577, 7904, 7267, 197, 154, "Output"]
}, Open  ]],
Cell[256859, 8104, 123, 3, 26, "Text"],
Cell[CellGroupData[{
Cell[257007, 8111, 145, 4, 27, "Input"],
Cell[257155, 8117, 58159, 1391, 1872, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[315351, 9513, 145, 4, 27, "Input"],
Cell[315499, 9519, 18477, 456, 339, "Output"]
}, Open  ]],
Cell[333991, 9978, 309, 10, 43, "Input"],
Cell[CellGroupData[{
Cell[334325, 9992, 869, 25, 27, "Input"],
Cell[335197, 10019, 46925, 782, 252, "Output"],
Cell[382125, 10803, 920, 29, 20, "Message"]
}, Open  ]],
Cell[CellGroupData[{
Cell[383082, 10837, 870, 25, 27, "Input"],
Cell[383955, 10864, 39240, 656, 249, "Output"]
}, Open  ]],
Cell[423210, 11523, 69, 2, 26, "Text"],
Cell[CellGroupData[{
Cell[423304, 11529, 787, 23, 27, "Input"],
Cell[424094, 11554, 30181, 505, 234, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
